
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega88(V)


#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



//volatile char tempspdr;
//#define Wait() while(!(SPSR&128)); tempspdr=SPDR



// Static functions and variables

register char tmpch @3;
register unsigned int line @4;





//===internal subroutines header
        void config(void);
        void draw_line(void);
// end header


//#pragma savereg-
register char i;
unsigned char flag=0;
// Syncro pulse routine
interrupt [2] void ext_int0_isr(void)
{
	TCNT0=0; // reset timer
	(*(unsigned char *) 0xb2)=61; // reset 80us interrupt
	while(TCNT0<180);//92); // wait 5us to see if H or V sync

	if(!(PIND.2)) { // its an H sync
		TCNT0=0; // reset timer
		line++;
		draw_line();
	}
	else { // tis a V sync
		if(line>200)line=0;
	}

}

char line_buffer[160];
char ahi_buffer[512];
//#include "oem866_6x8.c"
  /*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


     // #define byte unsigned char





//#include "X_convert_i.c" // inverted bitfields
//#include "X_convert.c" // normal font

unsigned char char_x=0,char_y=0;
/*
flash  unsigned char b2i[256]={                 // endian swapped bits lookup
0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,
72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,
196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,
44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,
162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,
106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,
230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,
30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,
81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,
57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,
181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,
125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,
243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,
135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,
79,207,47,175,111,239,31,159,95,223,63,191,127,255};
*/

flash char oem6x8[]={ // 6x8 DOS character set
flash char oem6x8[]={ 0,
0,
0,
0,
0,
0,
0,
0,
56,
68,
108,
68,
84,
68,
56,
0,
56,
124,
84,
124,
68,
124,
56,
0,
0,
40,
124,
124,
124,
56,
16,
0,
0,
16,
56,
124,
124,
56,
16,
0,
16,
56,
56,
16,
124,
124,
16,
0,
0,
16,
56,
124,
124,
16,
56,
0,
0,
0,
0,
48,
48,
0,
0,
0,
252,
252,
252,
204,
204,
252,
252,
252,
0,
0,
120,
72,
72,
120,
0,
0,
252,
252,
132,
180,
180,
132,
252,
252,
0,
28,
12,
52,
72,
72,
48,
0,
56,
68,
68,
56,
16,
56,
16,
0,
16,
24,
20,
16,
48,
112,
96,
0,
12,
52,
44,
52,
44,
108,
96,
0,
0,
84,
56,
108,
56,
84,
0,
0,
32,
48,
56,
60,
56,
48,
32,
0,
8,
24,
56,
120,
56,
24,
8,
0,
16,
56,
124,
16,
124,
56,
16,
0,
40,
40,
40,
40,
40,
0,
40,
0,
60,
84,
84,
52,
20,
20,
20,
0,
56,
68,
48,
40,
24,
68,
56,
0,
0,
0,
0,
0,
0,
120,
120,
0,
16,
56,
124,
16,
124,
56,
16,
56,
16,
56,
124,
16,
16,
16,
16,
0,
16,
16,
16,
16,
124,
56,
16,
0,
0,
16,
24,
124,
24,
16,
0,
0,
0,
16,
48,
124,
48,
16,
0,
0,
0,
0,
0,
64,
64,
64,
124,
0,
0,
40,
40,
124,
40,
40,
0,
0,
16,
16,
56,
56,
124,
124,
0,
0,
124,
124,
56,
56,
16,
16,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
56,
56,
16,
16,
0,
16,
0,
108,
108,
72,
0,
0,
0,
0,
0,
0,
40,
124,
40,
40,
124,
40,
0,
32,
56,
64,
48,
8,
112,
16,
0,
100,
100,
8,
16,
32,
76,
76,
0,
32,
80,
80,
32,
84,
72,
52,
0,
48,
48,
32,
0,
0,
0,
0,
0,
16,
32,
32,
32,
32,
32,
16,
0,
32,
16,
16,
16,
16,
16,
32,
0,
0,
40,
56,
124,
56,
40,
0,
0,
0,
16,
16,
124,
16,
16,
0,
0,
0,
0,
0,
0,
0,
48,
48,
32,
0,
0,
0,
124,
0,
0,
0,
0,
0,
0,
0,
0,
0,
48,
48,
0,
0,
4,
8,
16,
32,
64,
0,
0,
56,
68,
76,
84,
100,
68,
56,
0,
16,
48,
16,
16,
16,
16,
56,
0,
56,
68,
4,
24,
32,
64,
124,
0,
56,
68,
4,
56,
4,
68,
56,
0,
8,
24,
40,
72,
124,
8,
8,
0,
124,
64,
64,
120,
4,
68,
56,
0,
24,
32,
64,
120,
68,
68,
56,
0,
124,
4,
8,
16,
32,
32,
32,
0,
56,
68,
68,
56,
68,
68,
56,
0,
56,
68,
68,
60,
4,
8,
48,
0,
0,
0,
48,
48,
0,
48,
48,
0,
0,
0,
48,
48,
0,
48,
48,
32,
8,
16,
32,
64,
32,
16,
8,
0,
0,
0,
124,
0,
0,
124,
0,
0,
32,
16,
8,
4,
8,
16,
32,
0,
56,
68,
4,
24,
16,
0,
16,
0,
56,
68,
92,
84,
92,
64,
56,
0,
56,
68,
68,
68,
124,
68,
68,
0,
120,
68,
68,
120,
68,
68,
120,
0,
56,
68,
64,
64,
64,
68,
56,
0,
120,
68,
68,
68,
68,
68,
120,
0,
124,
64,
64,
120,
64,
64,
124,
0,
124,
64,
64,
120,
64,
64,
64,
0,
56,
68,
64,
92,
68,
68,
60,
0,
68,
68,
68,
124,
68,
68,
68,
0,
56,
16,
16,
16,
16,
16,
56,
0,
4,
4,
4,
4,
68,
68,
56,
0,
68,
72,
80,
96,
80,
72,
68,
0,
64,
64,
64,
64,
64,
64,
124,
0,
68,
108,
84,
68,
68,
68,
68,
0,
68,
100,
84,
76,
68,
68,
68,
0,
56,
68,
68,
68,
68,
68,
56,
0,
120,
68,
68,
120,
64,
64,
64,
0,
56,
68,
68,
68,
84,
72,
52,
0,
120,
68,
68,
120,
72,
68,
68,
0,
56,
68,
64,
56,
4,
68,
56,
0,
124,
16,
16,
16,
16,
16,
16,
0,
68,
68,
68,
68,
68,
68,
56,
0,
68,
68,
68,
68,
68,
40,
16,
0,
68,
68,
84,
84,
84,
84,
40,
0,
68,
68,
40,
16,
40,
68,
68,
0,
68,
68,
68,
40,
16,
16,
16,
0,
120,
8,
16,
32,
64,
64,
120,
0,
56,
32,
32,
32,
32,
32,
56,
0,
0,
64,
32,
16,
8,
4,
0,
0,
56,
8,
8,
8,
8,
8,
56,
0,
16,
40,
68,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
252,
48,
48,
16,
0,
0,
0,
0,
0,
0,
0,
56,
4,
60,
68,
60,
0,
64,
64,
120,
68,
68,
68,
120,
0,
0,
0,
56,
68,
64,
68,
56,
0,
4,
4,
60,
68,
68,
68,
60,
0,
0,
0,
56,
68,
120,
64,
56,
0,
24,
32,
32,
120,
32,
32,
32,
0,
0,
0,
60,
68,
68,
60,
4,
56,
64,
64,
112,
72,
72,
72,
72,
0,
16,
0,
16,
16,
16,
16,
24,
0,
8,
0,
24,
8,
8,
8,
72,
48,
64,
64,
72,
80,
96,
80,
72,
0,
16,
16,
16,
16,
16,
16,
24,
0,
0,
0,
104,
84,
84,
68,
68,
0,
0,
0,
112,
72,
72,
72,
72,
0,
0,
0,
56,
68,
68,
68,
56,
0,
0,
0,
120,
68,
68,
68,
120,
64,
0,
0,
60,
68,
68,
68,
60,
4,
0,
0,
88,
36,
32,
32,
112,
0,
0,
0,
56,
64,
56,
4,
56,
0,
0,
32,
120,
32,
32,
40,
16,
0,
0,
0,
72,
72,
72,
88,
40,
0,
0,
0,
68,
68,
68,
40,
16,
0,
0,
0,
68,
68,
84,
124,
40,
0,
0,
0,
72,
72,
48,
72,
72,
0,
0,
0,
72,
72,
72,
56,
16,
96,
0,
0,
120,
8,
48,
64,
120,
0,
24,
32,
32,
96,
32,
32,
24,
0,
16,
16,
16,
0,
16,
16,
16,
0,
48,
8,
8,
12,
8,
8,
48,
0,
40,
80,
0,
0,
0,
0,
0,
0,
16,
56,
108,
68,
68,
124,
0,
0
};

void lcd_msg1(flash char *text);
void beeper(unsigned char beeep);










unsigned char l_mask_array[8] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

void lcd_setpixel( short x,  short y, char pcolor) // pixel color: 1-set, 0-clear, 2-toggle
{unsigned short byte_off;
char bit_off,tmpc;
if (x>=64) return;
if (x<0) return;
if (y>=64) return;
if (y<0) return;
byte_off=(x>>3)+y*(64>>3);
bit_off=x & 7;
tmpc=ahi_buffer[byte_off];
if (pcolor==1) tmpc |= (l_mask_array[bit_off]);
if (pcolor==0) tmpc &= (l_mask_array[bit_off]) ^ 255 ;
if (pcolor==2) tmpc ^= (l_mask_array[bit_off]);
ahi_buffer[byte_off]=tmpc;
return;}

/*
flash unsigned char a2o[256] = {
0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F,
0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,
0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F,
0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F,
0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
0xFF, 0xF6, 0xF7, 0x20, 0xFD, 0xF2, 0x7C, 0x20, 0xF0, 0x20, 0xF4, 0x20, 0x20, 0x20, 0x20, 0xF8,
0xF8, 0xB1, 0xF6, 0xF7, 0xF3, 0x20, 0x20, 0xFA, 0xF1, 0xFC, 0xF5, 0x20, 0x20, 0x20, 0x20, 0xF9,
0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F,
0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9A, 0xDB, 0x9C, 0x9D, 0x9E, 0x9F,
0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF,
0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF
};
*/
/*static unsigned char o2a[256] = {
0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F,
0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,
0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F,
0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F,
0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF,
0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF,
0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF,
0x2D, 0x2D, 0x2D, 0x7C, 0x2B, 0x7C, 0x7C, 0x2D, 0x2D, 0x7C, 0x7C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D,
0x2D, 0x2B, 0x2D, 0x2B, 0x2D, 0x2B, 0x7C, 0x7C, 0x2D, 0x2D, 0x7C, 0x2D, 0x7C, 0x3D, 0x2B, 0x7C,
0x7C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2B, 0x2B, 0x2D, 0x2D, 0x2D, 0x2D, 0x7C, 0x7C, 0x2D,
0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF,
0xA8, 0xB8, 0xA5, 0xB4, 0xAA, 0xBA, 0xB2, 0xB3, 0xAF, 0xBF, 0xB7, 0xFB, 0xB9, 0xA4, 0xFE, 0xA0
};
  */


/*
void lcd_oemchar (byte glyph1) // put a char to the position. Color 0-normal, 1-inverted, 2-XOR
{unsigned short byte_off;
long bit_off;
byte bit_rem;
unsigned char tmpc,tmpz,icnt;
byte glyph;
unsigned short pchr;
glyph=a2o[glyph1];

bit_off=char_x+char_y*scr_width;
bit_rem=bit_off&7; // 00000001
if (bit_rem==0)
{
        byte_off=bit_off>>3;
        pchr=(short)glyph*font_height;
                for (icnt=0;icnt<font_height;icnt++)
                        {tmpc=b2i[font_set[pchr]]; pchr++;
                        tmpc |= ahi_buffer[byte_off];
                        ahi_buffer[byte_off]=tmpc;
                        byte_off+=scr_width>>3; // columns
                        }



}
else // 2 bytes split in halves
{
        byte_off=bit_off>>3;
        pchr=(short)glyph*font_height;
                for (icnt=0;icnt<font_height;icnt++)
                        {tmpc=b2i[font_set[pchr]]; pchr++;
                        tmpz=tmpc<<bit_rem;
                        tmpz |= ahi_buffer[byte_off];
                        ahi_buffer[byte_off]=tmpz;
                        tmpz=tmpc>>(8-bit_rem);
                        tmpz |= ahi_buffer[byte_off+1];
                        ahi_buffer[byte_off+1]=tmpz;

                        byte_off+=scr_width>>3; // columns
                        }





}
char_x+=font_width;
return;}
*/


 /*
void lcd_print(type_flash char *text) // curcol,currow,mode 0-normal,1-inverted,2-XOR
{char disp=0;
char tmpc;
while(*(text+disp)!=0)
{tmpc=*(text+disp);

lcd_oemchar(tmpc); // inc posn
disp++;
}
return;}
   */

void lcd_line(  short x1,  short y1,  short x2,  short y2,   short mode )
{
    int deltaX = abs(x2 - x1);
    int deltaY = abs(y2 - y1);
    int signX = x1 < x2 ? 1 : -1;
    int signY = y1 < y2 ? 1 : -1;
    int error = deltaX - deltaY;
    int error2;

    for (;;)
    {
        lcd_setpixel(x1, y1,mode);

        if(x1 == x2 && y1 == y2)
            break;

        error2 = error * 2;

        if(error2 > -deltaY)
        {
            error -= deltaY;
            x1 += signX;
        }

        if(error2 < deltaX)
        {
            error += deltaX;
            y1 += signY;
        }
    }
}

void lcd_circle(short xCenter, short yCenter, short radius, short mode)
 {  short tSwitch, y, x = 0;
    short d;
   d = yCenter - xCenter;
   y = radius;
   tSwitch = 3 - 2 * radius;
   while (x <= y)
    { lcd_setpixel(xCenter + x, yCenter + y, mode);
      lcd_setpixel(xCenter + x, yCenter - y, mode);
     lcd_setpixel(xCenter - x, yCenter + y, mode);
      lcd_setpixel(xCenter - x, yCenter - y, mode);
      lcd_setpixel(yCenter + y - d, yCenter + x, mode);
      lcd_setpixel(yCenter + y - d, yCenter - x, mode);
      lcd_setpixel(yCenter - y - d, yCenter + x, mode);
      lcd_setpixel(yCenter - y - d, yCenter - x, mode);
      if (tSwitch < 0)  tSwitch += (4 * x + 6);  else  { tSwitch += (4 * (x - y) + 10); y--; }
      x++;
    }
 }

 // tbitmap



// #include "pix.c"
/*void lcd_bmp(type_flash char *pix, char y, char x, char pmode) // mode 0-norm,1-inv,2-xor
// picture format: width,height,[bitmap]
{unsigned short tmc,x2,y2,baseoff;
char tmw,tmh,tmpc;
baseoff=x+(short)y*40*font_height; // base offset for x and y
tmw=(*pix)>>3; //width in bytes
tmh=*(pix+1) ;//height
tmc=2;
for (y2=0;y2<tmh;y2++)
{for (x2=0;x2<tmw;x2++)
     {
tmpc= *(pix+tmc);
if (pmode==2) tmpc ^= lcd_getb(0,baseoff);
if (pmode==1) tmpc ^=255;
lcd_putb(0,baseoff, tmpc);
baseoff++;
tmc++;
     }
baseoff+=40-tmw;
 }
return;} */
/*
void lcd_drawbox(unsigned short x,unsigned short y,unsigned short dispx,unsigned short dispy,char pmode)
{
lcd_line(x,y,x,y+dispy,pmode);
lcd_line(x,y,x+dispx,y,pmode);
lcd_line(x+dispx,y+dispy,x,y+dispy,pmode);
lcd_line(x+dispx,y+dispy,x+dispx,y,pmode);
return;}


void lcd_fillbox(unsigned short x,unsigned short y,unsigned short dispx,unsigned short dispy,char pmode)
{
unsigned short i,j;
i=y;j=y+dispy;
while (i<j)
{lcd_line(x,i,x+dispx,i,pmode);
i++;}
return;

}
*/
void intos(int x,long num,unsigned char dig,unsigned char zeros,unsigned char zpt) // pmode 5: into buffer
{
unsigned char cpush,leadz=0;
unsigned short div;
unsigned long rem;
    
if (num<0){num=-num;line_buffer[x++]='-';}
else line_buffer[x++]=' ';



rem=num;
if (dig>=7)
{
div=rem/1000000;
if (div) leadz=1;
rem-=1000000*div;
if (div | zeros| leadz|(zpt==6)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==6) line_buffer[x++]='.';
if (dig>=6)
{
div=rem/100000;
if (div) leadz=1;
rem-=100000*div;
if (div | zeros| leadz|(zpt==5)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==5) line_buffer[x++]='.';
if (dig>=5)
{
div=rem/10000;
if (div) leadz=1;
rem-=10000*div;
if (div | zeros | leadz|(zpt==4)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==4) line_buffer[x++]='.';
if (dig>=4)
{
div=rem/1000;
if (div) leadz=1;
rem-=1000*div;
if (div | zeros| leadz|(zpt==3)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==3) line_buffer[x++]='.';
if (dig>=3)
{
div=rem/100;
if (div) leadz=1;
rem-=100*div;
if (div | zeros| leadz|(zpt==2)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==2) line_buffer[x++]='.';
if (dig>=2)
{
div=rem/10;
if (div) leadz=1;
rem-=10*div;
if (div | zeros| leadz|(zpt==1)) {line_buffer[x++]=(div+0x30);}
}
if (zpt==1) line_buffer[x++]='.';

line_buffer[x++]=((unsigned char)rem+0x30);
}



/*
void lcd_arc(void) //  :)
{
signed int bx[30]={20,20,70,140,100,164,20,34,85,100,164,20,20,100,164,20,34,85,130,20,70,140,20,34,85,130,130,20,70,140};
signed int by[30]={100,164,50,100,164,20,100,164,20,34,185,30,120,70,40,50,120,70,40,20,34,185,30,34,185,30,120,70,40,50};
signed int br[30]={3,7,4,3,7,4,3,8,6,8,6,9,3,8,3,7,4,3,8,6,5,3,8,3,9,5,9,5,3,8};
signed int dbx[30]={1,-1,2,-1,2,1,-1,3,-1,1,3,-1,2,3,-1,3,1,-2,1,-2,-1,-2,-1,-2,1,1,2,-2,-1,-3};
signed int dby[30]={-5,-4,-2,-4,-2,-3,-3,-2,-3,-2,-3,-4,-2,-2,-2,-3,-3,-2,-2,-2,-4,-3,-2,-2,-3,-4,-4,-2,-2,-2};
byte ccnt;
int bxt,byt;

long k;
lcd_cls();

ccnt=25;while (ccnt){lcd_circle(bx[ccnt],by[ccnt],br[ccnt],1);ccnt--;}
arc_lp01:
ccnt=25;while (ccnt){
lcd_circle(bx[ccnt],by[ccnt],br[ccnt],0);
bxt=bx[ccnt]+dbx[ccnt];
byt=by[ccnt]+dby[ccnt];
if ((bxt>320)|(bxt<0)) dbx[ccnt]=-dbx[ccnt];
if ((byt>240)|(byt<0)) by[ccnt]=240;//dby[ccnt]=-dby[ccnt];
bx[ccnt]+=dbx[ccnt];
by[ccnt]+=dby[ccnt];
lcd_circle(bx[ccnt],by[ccnt],br[ccnt],1);
ccnt--;}
curcol=5;
currow=10;
lcd_print(" .   ",0);
curcol=13;
currow=11;
keyscan();
if (keybuf<6) return;//lcd_print("",0);
k=10;
while (k)
{k--;}

goto arc_lp01;
}

 */
//void lcd_dispframe






// Timer 2 overflow interrupt service routine // each 80 us, 2MHz tick
interrupt [10] void timer2_ovf_isr(void)
{
// Place your code here
	(*(unsigned char *) 0xb2)=177; // reset 80us interrupt
	//if (UCSR0A & (1<<RXC0)) MsgHandler(UDR0); //poll the serial port

}

// Declare your global variables here
int xx;
//==================================================

void lcd_cls(void)
{for (xx=0;xx<511;xx++)
ahi_buffer[xx]=0x0;
for (xx=0;xx<80;xx++)
line_buffer[xx]=0x0;
}                 
 //==================================================

void print(int pos,flash char *text)
{
int disp=0;
while(*(text+disp)!=0)
{line_buffer[pos+disp]=*(text+disp);
disp++;}
}
//==================================================

void draw_homebird(int hdg)
{
char j; // position from 0 to 63
if(hdg>179) hdg=hdg-360;
j=32-((hdg)*64)/360;

       // j=hdg;
 // central pixel
 lcd_setpixel(j,3,1);
 lcd_setpixel(j+1,4,1);
 lcd_setpixel(j-1,4,1);
 lcd_setpixel(j+2,5,1);
 lcd_setpixel(j-2,5,1);
}
//==================================================

void draw_pitchbird(int hdg)
{
unsigned char j; // position from 0 to 63
// pitch from -31 to +31
if (hdg< -31) hdg=-31;
if (hdg> 31) hdg=31;
 j=32+hdg;

 // central pixel
 lcd_setpixel(60,j,1);
 lcd_setpixel(59,j+1,1);
 lcd_setpixel(59,j-1,1);
 lcd_setpixel(58,j+2,1);
 lcd_setpixel(58,j-2,1);
}
//==================================================
void draw_ahiline(int roll)
{float sinr,cosr;
// line length 20
sinr=sin(roll*0.03488);
cosr=cos(roll*0.03488);
lcd_line(32-20*cosr,32+20*sinr,32+20*cosr,32-20*sinr,1);
lcd_line(32,32,32-8*sinr,32-8*cosr,1);
}


void display_vbat(void)
{ int jj;
(*(unsigned char *) 0x7c)=1 | (0x40 & 0xff);
// Start the AD conversion
(*(unsigned char *) 0x7a)|=0x40;
// Wait for the AD conversion to complete
while (((*(unsigned char *) 0x7a) & 0x10)==0);
(*(unsigned char *) 0x7a)|=0x10;

jj=(*(unsigned int *) 0x78) ;
jj=jj*3;
intos(0,jj,4,0,2); // print battery voltage (5 digs)
print(6,"V");





}

// process rx commands

//==================================================

unsigned char statZ=0;

unsigned char syncro=0xcb,pkt_ctr=0,pkt_type=0;
unsigned char rx_buf[11],pak_buf0[11],pak_buf1[11],pak_buf2[11];
unsigned char icnt,tmpr;
void receive_rx(void)
{
/*buffer format:
0-sync word changed (0xcb, 0x34)
1  packet type (0 - ahi,bat,cur,mah, 1 - nav, 2 - maintenance
2       0               1               2
3       roll            gpslat1         gpsSPD
4       pitch           gpslat2         gpsALTH
5       homeH           gpslat3         gpaALTL
6       homeL           gpslat4         gpsDISH
7       control_mode    gpslon1         gpsDISL
8       BATl            gpslon2         status
9       Ih              gpslon3         config
10      IL (up 80.0A)   gpslon4         emerg


==
status:
0..3
        0-Manual
*/

// this routine is called when received 1 byte
// 11 bytes length

tmpr=(*(unsigned char *) 0xc6);
statZ=tmpr;
        switch (pkt_type)
        {case 0: pak_buf0[pkt_ctr]=tmpr;break;
         case 1: pak_buf1[pkt_ctr]=tmpr;break;
         case 2: pak_buf2[pkt_ctr]=tmpr;break;
        }
if (pkt_ctr==0) //first byte received
        {if (tmpr==syncro) {pkt_ctr++;syncro^=255;}}
                //else dont increase
else pkt_ctr++; // non-first byte received
if(pkt_ctr==2) pkt_type=tmpr;
if (pkt_ctr==11) pkt_ctr=0; // end of packet

}

//==================================================
// graphic variables
signed char v_pitch=0,v_roll=0;
signed int v_home=0;
//==================================================

void process0(void) // process the packet0
{
/*
0-sync word changed (0xcb, 0x34)
1  packet type (0 - ahi,bat,cur,mah, 1 - nav, 2 - maintenance
2       0    
3       roll 
4       pitch
5       homeH
6       homeL
7       control_mode
8       0
9       Ih
10      IL (up 80.0A)
*/
v_roll=pak_buf0[3];
v_pitch=pak_buf0[4];
v_home=((int)pak_buf0[5]<<8)|pak_buf0[6];
switch(pak_buf0[7])
        {case 0: print(30,"MANUAL");break;
         case 1: print(30,"CIRCLE");break;
        case 2: print(30,"STABILIZE");break;
        case 5: print(30,"WIRE A");break;
        case 6: print(30,"WIRE B");break;
        case 10: print(30,"AUTOPILOT");break;
        case 11: print(30,"RETURN");break;
        case 12: print(30,"HOLD");break;
        case 13: print(30,"TAKEOFF");break;
        case 14: print(30,"LANDING");break;
        
        
        }

/*
#define MANUAL 0
#define CIRCLE 1
#define STABILIZE 2

#define FLY_BY_WIRE_A 5
#define FLY_BY_WIRE_B 6
			
#define AUTO 10
#define RTL 11
#define LOITER 12
#define TAKEOFF 13
#define LAND 14
*/
intos(40,((int)pak_buf0[9]<<8)|pak_buf0[10],3,0,1); // print current (5 digs)
print(45,"A");
}
//==================================================




unsigned char time_sec=0;
unsigned char time_sec1=0;
unsigned char time_min=0;
unsigned char time_min1=0;
unsigned char time_hr=0;

void count_time(void) // 50Hz
{static char cnt=0;
cnt++;
if (cnt<50) return;
cnt=0;
time_sec++; if (time_sec>9) {time_sec=0;time_sec1++;}
if (time_sec1>5) {time_sec1=0;time_min++;}
if (time_min>9) {time_min=0;time_min1++;}
if (time_min1>5) {time_min1=0;time_hr++;}
}


void main(void)
{ 
config();
SMCR=1;
lcd_cls();  
//print(0, "10.7V 5400mAh    Dis11500      AUTOPILOT");
//print(40,"20.4A    SPD 178   ALT 2500    HDOP 1.2 ");
print(0, "                                        ");
print(40,"                                        ");


while(1)
{// loop

if (flag)     //50 Hz
{
  flag=0;
  lcd_cls();
  count_time();
  line_buffer[1]++;
// draw scales and crosshair
for(i=0;i<64;i+=4)
lcd_setpixel(i,0,1);
for(i=0;i<64;i+=16) // upper scale (home)
{lcd_setpixel(i,1,1);
lcd_setpixel(i,2,1);}

for(i=0;i<64;i+=4) // right scale (pitch)
lcd_setpixel(63,i,1);
for(i=0;i<64;i+=16) //
{lcd_setpixel(62,i,1);
lcd_setpixel(61,i,1);}

// home bird
draw_homebird(v_home);
draw_pitchbird(v_pitch);
lcd_circle(32,32,2,1);
draw_ahiline(v_roll);

process0();
display_vbat();


// print clocks at line2
line_buffer[56]=time_hr+0x30;
line_buffer[57]=':';
line_buffer[58]=time_min1+0x30;
line_buffer[59]=time_min+0x30;
line_buffer[60]=':';
line_buffer[61]=time_sec1+0x30;
line_buffer[62]=time_sec+0x30;




 }

#asm   
sleep
#endasm
} // end main loop
}








	

//***************************Line drawing routine
// 2x40 line buffer
// 64x64 graphics buffer
void draw_line(void)
{
#asm("push r31 push r30");
if(line==30){	SPCR = (1<<6) | (1<<4) | (1<<2);}
	if ((line >= 40) && (line < (48))) // 1st line of 40 chars 8x8
	{
		TCNT0=0;
		while(TCNT0<213); //wait ~7.5us from H-sync 
	        tmpch=line-40;// R3
	        DDRB.1=1;
		PORTB.1=0;         
        #asm
clr r15 // zero register
ldi r18,40   // counter downto 0
ldi r27,high(_line_buffer)
ldi r26,low(_line_buffer) // XL
ldi r17,8
        // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
write_str:
ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
lpm r16,Z out SPDR,r16 dec r18 brne write_str
//        wait_t:
//        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
#endasm
TCNT0=0;
while(TCNT0<20);
	        DDRB.1=0;
	}
	
	else if ((line >= 52) && (line < (60))) // 2nd line of 40 chars 8x8
	{
		TCNT0=0;
		while(TCNT0<203); //wait ~7.5us from H-sync  // 10 pts each condition
	        tmpch=line-52;// R3
	        DDRB.1=1;
		PORTB.1=0;         
        #asm
clr r15 // zero register
ldi r18,40   // counter downto 0
ldi r27,high(_line_buffer+40)
ldi r26,low(_line_buffer+40) // XL
ldi r17,8
        // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
write_str1:
ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
lpm r16,Z out SPDR,r16 dec r18 brne write_str1
//        wait_t:
//        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
#endasm
TCNT0=0;
while(TCNT0<20);
DDRB.1=0;
	} 
//##################### Graphics 64x64
	else if ((line >= 135) && (line < (135+64))) // 2nd line of 40 chars 8x8
	{
		TCNT0=0;
		while(TCNT0<218); //wait ~7.5us from H-sync  // 10 pts each condition
		TCNT0=0;
		while(TCNT0<214); //wait ~7.5us from H-sync  // 10 pts each condition
	        tmpch=line-135;// R3
	        DDRB.1=1;
	        PORTB.1=0;
		//PORTB.1=1; 
        #asm
ldi r18,8   // counter downto 0
ldi r27,high(_ahi_buffer)
ldi r26,low(_ahi_buffer) // XL
ldi r17,8
mul r3,r17
add r26,r0
adc r27,r1
        // main cycle: spdr=ahi_buffer[8*r3+r18]
#define _PORTB 5
write_str2:
ld r16,X+  
rol r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
nop   
nop   
ror r16
out _PORTB,r16
   
ror r16
dec r18
out _PORTB,r16
brne write_str2

PORTB.1=0;
DDRB.1=0;

	}else if (line==135+64) {flag=1;}


if((*(unsigned char *) 0xc0)&128) receive_rx();


#asm("pop r30 pop r31");

//***************************end Line drawing routine
}














void config(void)
{
	// PORT B - Video Out
	//PB0 used for background dimming
	PORTB = 0x00;							// Initial state is everything off
	DDRB  = 0x3d;							// Data direction register for port B
        DDRB.1=1;
	// PORT D - Not really used
	//	Bit/Pin 2 (out) connected the control line on a servo
	PORTD = 0x00;							// Initial state is everything off
	DDRD  = 0x00;							// Data direction register for port D
	
	//enable the SPI port
	SPDR = 0; //CLEAR THE SPI DATA REGISTER!!! OR WILL HOSE THE VIDEO RANDOMLY IF NOT CLEARED!
	SPCR = (1<<6) | (1<<4) | (1<<2);
	SPSR = 1;

	// Set baud rate of USART to 9600 baud at 8 MHz
(*(unsigned char *) 0xc0)=0x00;
(*(unsigned char *) 0xc1)=0x10;
(*(unsigned char *) 0xc2)=0x06;
(*(unsigned char *) 0xc5)=0x00;
(*(unsigned char *) 0xc4)=0x9f;//0x33;

	// Setup idle mode sleeps

	//set_sleep_mode(SLEEP_MODE_IDLE);
	
	TCCR0B = 0x01; //enable timer w/ no prescaling
	
	(*(unsigned char *) 0xb1) = 0x02; //enable timer with /8 prescale
	(*(unsigned char *) 0xb2) = 84; //overflow will happen after 80us
	
	//TIMSK2 = 1;

	(*(unsigned char *) 0x69)=3; // interrupt for char generator
	EIMSK=1;
	line=line_buffer[0];
ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

// ADC initialization
// ADC Clock frequency: 125.000 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: Free Running
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
(*(unsigned char *) 0x7e)=0x00;
(*(unsigned char *) 0x7c)=0x40 & 0xff;
(*(unsigned char *) 0x7a)=0xA6;
(*(unsigned char *) 0x7b)&=0xF8;


	line=0; //reset the line counter

#asm("sei")

}
