
;CodeVisionAVR C Compiler V1.25.3 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega88
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E
	.EQU GPIOR1=0x2A
	.EQU GPIOR2=0x2B

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "mpo.vec"
	.INCLUDE "mpo.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x180)
	LDI  R29,HIGH(0x180)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180
;       1 
;       2 #include <mega88.h>
;       3 #define byte unsigned char
;       4 //volatile char tempspdr;
;       5 //#define Wait() while(!(SPSR&128)); tempspdr=SPDR
;       6 
;       7 
;       8 
;       9 // Static functions and variables
;      10 
;      11 register char tmpch @3;
;      12 register unsigned int line @4;
;      13 
;      14 
;      15 
;      16 
;      17 
;      18 //===internal subroutines header
;      19         void config(void);
;      20         void draw_line(void);
;      21 // end header
;      22 
;      23 
;      24 //#pragma savereg-
;      25 register char i;
;      26 byte flag=0;
;      27 // Syncro pulse routine
;      28 interrupt [EXT_INT0] void ext_int0_isr(void)
;      29 {

	.CSEG
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      30 	TCNT0=0; // reset timer
	LDI  R30,LOW(0)
	OUT  0x26,R30
;      31 	TCNT2=61; // reset 80us interrupt
	LDI  R30,LOW(61)
	STS  178,R30
;      32 	while(TCNT0<180);//92); // wait 5us to see if H or V sync
_0x3:
	IN   R30,0x26
	CPI  R30,LOW(0xB4)
	BRLO _0x3
;      33 
;      34 	if(!(PIND.2)) { // its an H sync
	SBIC 0x9,2
	RJMP _0x6
;      35 		TCNT0=0; // reset timer
	LDI  R30,LOW(0)
	OUT  0x26,R30
;      36 		line++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;      37 		draw_line();
	RCALL _draw_line
;      38 	}
;      39 	else { // tis a V sync
	RJMP _0x7
_0x6:
;      40 		if(line>200)line=0;
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	CP   R30,R4
	CPC  R31,R5
	BRSH _0x8
	CLR  R4
	CLR  R5
;      41 	}
_0x8:
_0x7:
;      42 
;      43 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      44 
;      45 char line_buffer[160];

	.DSEG
_line_buffer:
	.BYTE 0xA0
;      46 char ahi_buffer[512];
_ahi_buffer:
	.BYTE 0x200
;      47 #include "X_convert.c"
;      48 #define ________ 0
;      49 #define _______X 1
;      50 #define ______X_ 2
;      51 #define ______XX 3
;      52 #define _____X__ 4
;      53 #define _____X_X 5
;      54 #define _____XX_ 6
;      55 #define _____XXX 7
;      56 #define ____X___ 8
;      57 #define ____X__X 9
;      58 #define ____X_X_ 10
;      59 #define ____X_XX 11
;      60 #define ____XX__ 12
;      61 #define ____XX_X 13
;      62 #define ____XXX_ 14
;      63 #define ____XXXX 15
;      64 #define ___X____ 16
;      65 #define ___X___X 17
;      66 #define ___X__X_ 18
;      67 #define ___X__XX 19
;      68 #define ___X_X__ 20
;      69 #define ___X_X_X 21
;      70 #define ___X_XX_ 22
;      71 #define ___X_XXX 23
;      72 #define ___XX___ 24
;      73 #define ___XX__X 25
;      74 #define ___XX_X_ 26
;      75 #define ___XX_XX 27
;      76 #define ___XXX__ 28
;      77 #define ___XXX_X 29
;      78 #define ___XXXX_ 30
;      79 #define ___XXXXX 31
;      80 #define __X_____ 32
;      81 #define __X____X 33
;      82 #define __X___X_ 34
;      83 #define __X___XX 35
;      84 #define __X__X__ 36
;      85 #define __X__X_X 37
;      86 #define __X__XX_ 38
;      87 #define __X__XXX 39
;      88 #define __X_X___ 40
;      89 #define __X_X__X 41
;      90 #define __X_X_X_ 42
;      91 #define __X_X_XX 43
;      92 #define __X_XX__ 44
;      93 #define __X_XX_X 45
;      94 #define __X_XXX_ 46
;      95 #define __X_XXXX 47
;      96 #define __XX____ 48
;      97 #define __XX___X 49
;      98 #define __XX__X_ 50
;      99 #define __XX__XX 51
;     100 #define __XX_X__ 52
;     101 #define __XX_X_X 53
;     102 #define __XX_XX_ 54
;     103 #define __XX_XXX 55
;     104 #define __XXX___ 56
;     105 #define __XXX__X 57
;     106 #define __XXX_X_ 58
;     107 #define __XXX_XX 59
;     108 #define __XXXX__ 60
;     109 #define __XXXX_X 61
;     110 #define __XXXXX_ 62
;     111 #define __XXXXXX 63
;     112 #define _X______ 64
;     113 #define _X_____X 65
;     114 #define _X____X_ 66
;     115 #define _X____XX 67
;     116 #define _X___X__ 68
;     117 #define _X___X_X 69
;     118 #define _X___XX_ 70
;     119 #define _X___XXX 71
;     120 #define _X__X___ 72
;     121 #define _X__X__X 73
;     122 #define _X__X_X_ 74
;     123 #define _X__X_XX 75
;     124 #define _X__XX__ 76
;     125 #define _X__XX_X 77
;     126 #define _X__XXX_ 78
;     127 #define _X__XXXX 79
;     128 #define _X_X____ 80
;     129 #define _X_X___X 81
;     130 #define _X_X__X_ 82
;     131 #define _X_X__XX 83
;     132 #define _X_X_X__ 84
;     133 #define _X_X_X_X 85
;     134 #define _X_X_XX_ 86
;     135 #define _X_X_XXX 87
;     136 #define _X_XX___ 88
;     137 #define _X_XX__X 89
;     138 #define _X_XX_X_ 90
;     139 #define _X_XX_XX 91
;     140 #define _X_XXX__ 92
;     141 #define _X_XXX_X 93
;     142 #define _X_XXXX_ 94
;     143 #define _X_XXXXX 95
;     144 #define _XX_____ 96
;     145 #define _XX____X 97
;     146 #define _XX___X_ 98
;     147 #define _XX___XX 99
;     148 #define _XX__X__ 100
;     149 #define _XX__X_X 101
;     150 #define _XX__XX_ 102
;     151 #define _XX__XXX 103
;     152 #define _XX_X___ 104
;     153 #define _XX_X__X 105
;     154 #define _XX_X_X_ 106
;     155 #define _XX_X_XX 107
;     156 #define _XX_XX__ 108
;     157 #define _XX_XX_X 109
;     158 #define _XX_XXX_ 110
;     159 #define _XX_XXXX 111
;     160 #define _XXX____ 112
;     161 #define _XXX___X 113
;     162 #define _XXX__X_ 114
;     163 #define _XXX__XX 115
;     164 #define _XXX_X__ 116
;     165 #define _XXX_X_X 117
;     166 #define _XXX_XX_ 118
;     167 #define _XXX_XXX 119
;     168 #define _XXXX___ 120
;     169 #define _XXXX__X 121
;     170 #define _XXXX_X_ 122
;     171 #define _XXXX_XX 123
;     172 #define _XXXXX__ 124
;     173 #define _XXXXX_X 125
;     174 #define _XXXXXX_ 126
;     175 #define _XXXXXXX 127
;     176 #define X_______ 128
;     177 #define X______X 129
;     178 #define X_____X_ 130
;     179 #define X_____XX 131
;     180 #define X____X__ 132
;     181 #define X____X_X 133
;     182 #define X____XX_ 134
;     183 #define X____XXX 135
;     184 #define X___X___ 136
;     185 #define X___X__X 137
;     186 #define X___X_X_ 138
;     187 #define X___X_XX 139
;     188 #define X___XX__ 140
;     189 #define X___XX_X 141
;     190 #define X___XXX_ 142
;     191 #define X___XXXX 143
;     192 #define X__X____ 144
;     193 #define X__X___X 145
;     194 #define X__X__X_ 146
;     195 #define X__X__XX 147
;     196 #define X__X_X__ 148
;     197 #define X__X_X_X 149
;     198 #define X__X_XX_ 150
;     199 #define X__X_XXX 151
;     200 #define X__XX___ 152
;     201 #define X__XX__X 153
;     202 #define X__XX_X_ 154
;     203 #define X__XX_XX 155
;     204 #define X__XXX__ 156
;     205 #define X__XXX_X 157
;     206 #define X__XXXX_ 158
;     207 #define X__XXXXX 159
;     208 #define X_X_____ 160
;     209 #define X_X____X 161
;     210 #define X_X___X_ 162
;     211 #define X_X___XX 163
;     212 #define X_X__X__ 164
;     213 #define X_X__X_X 165
;     214 #define X_X__XX_ 166
;     215 #define X_X__XXX 167
;     216 #define X_X_X___ 168
;     217 #define X_X_X__X 169
;     218 #define X_X_X_X_ 170
;     219 #define X_X_X_XX 171
;     220 #define X_X_XX__ 172
;     221 #define X_X_XX_X 173
;     222 #define X_X_XXX_ 174
;     223 #define X_X_XXXX 175
;     224 #define X_XX____ 176
;     225 #define X_XX___X 177
;     226 #define X_XX__X_ 178
;     227 #define X_XX__XX 179
;     228 #define X_XX_X__ 180
;     229 #define X_XX_X_X 181
;     230 #define X_XX_XX_ 182
;     231 #define X_XX_XXX 183
;     232 #define X_XXX___ 184
;     233 #define X_XXX__X 185
;     234 #define X_XXX_X_ 186
;     235 #define X_XXX_XX 187
;     236 #define X_XXXX__ 188
;     237 #define X_XXXX_X 189
;     238 #define X_XXXXX_ 190
;     239 #define X_XXXXXX 191
;     240 #define XX______ 192
;     241 #define XX_____X 193
;     242 #define XX____X_ 194
;     243 #define XX____XX 195
;     244 #define XX___X__ 196
;     245 #define XX___X_X 197
;     246 #define XX___XX_ 198
;     247 #define XX___XXX 199
;     248 #define XX__X___ 200
;     249 #define XX__X__X 201
;     250 #define XX__X_X_ 202
;     251 #define XX__X_XX 203
;     252 #define XX__XX__ 204
;     253 #define XX__XX_X 205
;     254 #define XX__XXX_ 206
;     255 #define XX__XXXX 207
;     256 #define XX_X____ 208
;     257 #define XX_X___X 209
;     258 #define XX_X__X_ 210
;     259 #define XX_X__XX 211
;     260 #define XX_X_X__ 212
;     261 #define XX_X_X_X 213
;     262 #define XX_X_XX_ 214
;     263 #define XX_X_XXX 215
;     264 #define XX_XX___ 216
;     265 #define XX_XX__X 217
;     266 #define XX_XX_X_ 218
;     267 #define XX_XX_XX 219
;     268 #define XX_XXX__ 220
;     269 #define XX_XXX_X 221
;     270 #define XX_XXXX_ 222
;     271 #define XX_XXXXX 223
;     272 #define XXX_____ 224
;     273 #define XXX____X 225
;     274 #define XXX___X_ 226
;     275 #define XXX___XX 227
;     276 #define XXX__X__ 228
;     277 #define XXX__X_X 229
;     278 #define XXX__XX_ 230
;     279 #define XXX__XXX 231
;     280 #define XXX_X___ 232
;     281 #define XXX_X__X 233
;     282 #define XXX_X_X_ 234
;     283 #define XXX_X_XX 235
;     284 #define XXX_XX__ 236
;     285 #define XXX_XX_X 237
;     286 #define XXX_XXX_ 238
;     287 #define XXX_XXXX 239
;     288 #define XXXX____ 240
;     289 #define XXXX___X 241
;     290 #define XXXX__X_ 242
;     291 #define XXXX__XX 243
;     292 #define XXXX_X__ 244
;     293 #define XXXX_X_X 245
;     294 #define XXXX_XX_ 246
;     295 #define XXXX_XXX 247
;     296 #define XXXXX___ 248
;     297 #define XXXXX__X 249
;     298 #define XXXXX_X_ 250
;     299 #define XXXXX_XX 251
;     300 #define XXXXXX__ 252
;     301 #define XXXXXX_X 253
;     302 #define XXXXXXX_ 254
;     303 #define XXXXXXXX 255
;     304 //#include "oem866_6x8.c"
;     305 #include "s1d13705.c"
;     306 #define target_avr       // define for codevision; empty for builder
;     307   #include <math.h>
;     308 #ifdef target_avr
;     309  #define type_flash flash
;     310  #define IBB // inverted endian in S1D13705 !!!!
;     311  #define bool bit
;     312  #define true 1
;     313  #define false 0
;     314 // #define byte unsigned char
;     315 #else
;     316 #define type_flash const
;     317 #endif
;     318 
;     319 
;     320 
;     321 
;     322 #define CLK PORTC.0
;     323 #define ASL PORTC.1
;     324 #define ASH PORTC.2
;     325 #define WE PORTC.3
;     326 #define RD PORTC.4
;     327 #define CS PORTC.5
;     328 #define WAIT PINC.6
;     329 #define A16 PORTD.7
;     330 #define nop #asm("nop");
;     331 
;     332 #define font_height 8
;     333 #define font_width 6
;     334 #define scr_height 64
;     335 #define scr_width 64
;     336 #define font_set oem6x8
;     337 //#include "X_convert_i.c" // inverted bitfields
;     338 //#include "X_convert.c" // normal font
;     339 
;     340 byte char_x=0,char_y=0;
;     341 /*
;     342 flash  unsigned char b2i[256]={                 // endian swapped bits lookup
;     343 0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,
;     344 72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,
;     345 196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,
;     346 44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,
;     347 162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,
;     348 106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,
;     349 230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,
;     350 30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,
;     351 81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,
;     352 57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,
;     353 181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,
;     354 125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,
;     355 243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,
;     356 135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,
;     357 79,207,47,175,111,239,31,159,95,223,63,191,127,255};
;     358 */
;     359 
;     360 #include "oem866_6x8.c"
;     361 flash char oem6x8[]={ // 6x8 DOS character set

	.CSEG
;     362 ________,
;     363 ________,
;     364 ________,
;     365 ________,
;     366 ________,
;     367 ________,
;     368 ________,
;     369 ________,
;     370 __XXX___,
;     371 _X___X__,
;     372 _XX_XX__,
;     373 _X___X__,
;     374 _X_X_X__,
;     375 _X___X__,
;     376 __XXX___,
;     377 ________,
;     378 __XXX___,
;     379 _XXXXX__,
;     380 _X_X_X__,
;     381 _XXXXX__,
;     382 _X___X__,
;     383 _XXXXX__,
;     384 __XXX___,
;     385 ________,
;     386 ________,
;     387 __X_X___,
;     388 _XXXXX__,
;     389 _XXXXX__,
;     390 _XXXXX__,
;     391 __XXX___,
;     392 ___X____,
;     393 ________,
;     394 ________,
;     395 ___X____,
;     396 __XXX___,
;     397 _XXXXX__,
;     398 _XXXXX__,
;     399 __XXX___,
;     400 ___X____,
;     401 ________,
;     402 ___X____,
;     403 __XXX___,
;     404 __XXX___,
;     405 ___X____,
;     406 _XXXXX__,
;     407 _XXXXX__,
;     408 ___X____,
;     409 ________,
;     410 ________,
;     411 ___X____,
;     412 __XXX___,
;     413 _XXXXX__,
;     414 _XXXXX__,
;     415 ___X____,
;     416 __XXX___,
;     417 ________,
;     418 ________,
;     419 ________,
;     420 ________,
;     421 __XX____,
;     422 __XX____,
;     423 ________,
;     424 ________,
;     425 ________,
;     426 XXXXXX__,
;     427 XXXXXX__,
;     428 XXXXXX__,
;     429 XX__XX__,
;     430 XX__XX__,
;     431 XXXXXX__,
;     432 XXXXXX__,
;     433 XXXXXX__,
;     434 ________,
;     435 ________,
;     436 _XXXX___,
;     437 _X__X___,
;     438 _X__X___,
;     439 _XXXX___,
;     440 ________,
;     441 ________,
;     442 XXXXXX__,
;     443 XXXXXX__,
;     444 X____X__,
;     445 X_XX_X__,
;     446 X_XX_X__,
;     447 X____X__,
;     448 XXXXXX__,
;     449 XXXXXX__,
;     450 ________,
;     451 ___XXX__,
;     452 ____XX__,
;     453 __XX_X__,
;     454 _X__X___,
;     455 _X__X___,
;     456 __XX____,
;     457 ________,
;     458 __XXX___,
;     459 _X___X__,
;     460 _X___X__,
;     461 __XXX___,
;     462 ___X____,
;     463 __XXX___,
;     464 ___X____,
;     465 ________,
;     466 ___X____,
;     467 ___XX___,
;     468 ___X_X__,
;     469 ___X____,
;     470 __XX____,
;     471 _XXX____,
;     472 _XX_____,
;     473 ________,
;     474 ____XX__,
;     475 __XX_X__,
;     476 __X_XX__,
;     477 __XX_X__,
;     478 __X_XX__,
;     479 _XX_XX__,
;     480 _XX_____,
;     481 ________,
;     482 ________,
;     483 _X_X_X__,
;     484 __XXX___,
;     485 _XX_XX__,
;     486 __XXX___,
;     487 _X_X_X__,
;     488 ________,
;     489 ________,
;     490 __X_____,
;     491 __XX____,
;     492 __XXX___,
;     493 __XXXX__,
;     494 __XXX___,
;     495 __XX____,
;     496 __X_____,
;     497 ________,
;     498 ____X___,
;     499 ___XX___,
;     500 __XXX___,
;     501 _XXXX___,
;     502 __XXX___,
;     503 ___XX___,
;     504 ____X___,
;     505 ________,
;     506 ___X____,
;     507 __XXX___,
;     508 _XXXXX__,
;     509 ___X____,
;     510 _XXXXX__,
;     511 __XXX___,
;     512 ___X____,
;     513 ________,
;     514 __X_X___,
;     515 __X_X___,
;     516 __X_X___,
;     517 __X_X___,
;     518 __X_X___,
;     519 ________,
;     520 __X_X___,
;     521 ________,
;     522 __XXXX__,
;     523 _X_X_X__,
;     524 _X_X_X__,
;     525 __XX_X__,
;     526 ___X_X__,
;     527 ___X_X__,
;     528 ___X_X__,
;     529 ________,
;     530 __XXX___,
;     531 _X___X__,
;     532 __XX____,
;     533 __X_X___,
;     534 ___XX___,
;     535 _X___X__,
;     536 __XXX___,
;     537 ________,
;     538 ________,
;     539 ________,
;     540 ________,
;     541 ________,
;     542 ________,
;     543 _XXXX___,
;     544 _XXXX___,
;     545 ________,
;     546 ___X____,
;     547 __XXX___,
;     548 _XXXXX__,
;     549 ___X____,
;     550 _XXXXX__,
;     551 __XXX___,
;     552 ___X____,
;     553 __XXX___,
;     554 ___X____,
;     555 __XXX___,
;     556 _XXXXX__,
;     557 ___X____,
;     558 ___X____,
;     559 ___X____,
;     560 ___X____,
;     561 ________,
;     562 ___X____,
;     563 ___X____,
;     564 ___X____,
;     565 ___X____,
;     566 _XXXXX__,
;     567 __XXX___,
;     568 ___X____,
;     569 ________,
;     570 ________,
;     571 ___X____,
;     572 ___XX___,
;     573 _XXXXX__,
;     574 ___XX___,
;     575 ___X____,
;     576 ________,
;     577 ________,
;     578 ________,
;     579 ___X____,
;     580 __XX____,
;     581 _XXXXX__,
;     582 __XX____,
;     583 ___X____,
;     584 ________,
;     585 ________,
;     586 ________,
;     587 ________,
;     588 ________,
;     589 _X______,
;     590 _X______,
;     591 _X______,
;     592 _XXXXX__,
;     593 ________,
;     594 ________,
;     595 __X_X___,
;     596 __X_X___,
;     597 _XXXXX__,
;     598 __X_X___,
;     599 __X_X___,
;     600 ________,
;     601 ________,
;     602 ___X____,
;     603 ___X____,
;     604 __XXX___,
;     605 __XXX___,
;     606 _XXXXX__,
;     607 _XXXXX__,
;     608 ________,
;     609 ________,
;     610 _XXXXX__,
;     611 _XXXXX__,
;     612 __XXX___,
;     613 __XXX___,
;     614 ___X____,
;     615 ___X____,
;     616 ________,
;     617 ________,
;     618 ________,
;     619 ________,
;     620 ________,
;     621 ________,
;     622 ________,
;     623 ________,
;     624 ________,
;     625 ________,
;     626 ___X____,
;     627 __XXX___,
;     628 __XXX___,
;     629 ___X____,
;     630 ___X____,
;     631 ________,
;     632 ___X____,
;     633 ________,
;     634 _XX_XX__,
;     635 _XX_XX__,
;     636 _X__X___,
;     637 ________,
;     638 ________,
;     639 ________,
;     640 ________,
;     641 ________,
;     642 ________,
;     643 __X_X___,
;     644 _XXXXX__,
;     645 __X_X___,
;     646 __X_X___,
;     647 _XXXXX__,
;     648 __X_X___,
;     649 ________,
;     650 __X_____,
;     651 __XXX___,
;     652 _X______,
;     653 __XX____,
;     654 ____X___,
;     655 _XXX____,
;     656 ___X____,
;     657 ________,
;     658 _XX__X__,
;     659 _XX__X__,
;     660 ____X___,
;     661 ___X____,
;     662 __X_____,
;     663 _X__XX__,
;     664 _X__XX__,
;     665 ________,
;     666 __X_____,
;     667 _X_X____,
;     668 _X_X____,
;     669 __X_____,
;     670 _X_X_X__,
;     671 _X__X___,
;     672 __XX_X__,
;     673 ________,
;     674 __XX____,
;     675 __XX____,
;     676 __X_____,
;     677 ________,
;     678 ________,
;     679 ________,
;     680 ________,
;     681 ________,
;     682 ___X____,
;     683 __X_____,
;     684 __X_____,
;     685 __X_____,
;     686 __X_____,
;     687 __X_____,
;     688 ___X____,
;     689 ________,
;     690 __X_____,
;     691 ___X____,
;     692 ___X____,
;     693 ___X____,
;     694 ___X____,
;     695 ___X____,
;     696 __X_____,
;     697 ________,
;     698 ________,
;     699 __X_X___,
;     700 __XXX___,
;     701 _XXXXX__,
;     702 __XXX___,
;     703 __X_X___,
;     704 ________,
;     705 ________,
;     706 ________,
;     707 ___X____,
;     708 ___X____,
;     709 _XXXXX__,
;     710 ___X____,
;     711 ___X____,
;     712 ________,
;     713 ________,
;     714 ________,
;     715 ________,
;     716 ________,
;     717 ________,
;     718 ________,
;     719 __XX____,
;     720 __XX____,
;     721 __X_____,
;     722 ________,
;     723 ________,
;     724 ________,
;     725 _XXXXX__,
;     726 ________,
;     727 ________,
;     728 ________,
;     729 ________,
;     730 ________,
;     731 ________,
;     732 ________,
;     733 ________,
;     734 ________,
;     735 __XX____,
;     736 __XX____,
;     737 ________,
;     738 ________,
;     739 _____X__,
;     740 ____X___,
;     741 ___X____,
;     742 __X_____,
;     743 _X______,
;     744 ________,
;     745 ________,
;     746 __XXX___,
;     747 _X___X__,
;     748 _X__XX__,
;     749 _X_X_X__,
;     750 _XX__X__,
;     751 _X___X__,
;     752 __XXX___,
;     753 ________,
;     754 ___X____,
;     755 __XX____,
;     756 ___X____,
;     757 ___X____,
;     758 ___X____,
;     759 ___X____,
;     760 __XXX___,
;     761 ________,
;     762 __XXX___,
;     763 _X___X__,
;     764 _____X__,
;     765 ___XX___,
;     766 __X_____,
;     767 _X______,
;     768 _XXXXX__,
;     769 ________,
;     770 __XXX___,
;     771 _X___X__,
;     772 _____X__,
;     773 __XXX___,
;     774 _____X__,
;     775 _X___X__,
;     776 __XXX___,
;     777 ________,
;     778 ____X___,
;     779 ___XX___,
;     780 __X_X___,
;     781 _X__X___,
;     782 _XXXXX__,
;     783 ____X___,
;     784 ____X___,
;     785 ________,
;     786 _XXXXX__,
;     787 _X______,
;     788 _X______,
;     789 _XXXX___,
;     790 _____X__,
;     791 _X___X__,
;     792 __XXX___,
;     793 ________,
;     794 ___XX___,
;     795 __X_____,
;     796 _X______,
;     797 _XXXX___,
;     798 _X___X__,
;     799 _X___X__,
;     800 __XXX___,
;     801 ________,
;     802 _XXXXX__,
;     803 _____X__,
;     804 ____X___,
;     805 ___X____,
;     806 __X_____,
;     807 __X_____,
;     808 __X_____,
;     809 ________,
;     810 __XXX___,
;     811 _X___X__,
;     812 _X___X__,
;     813 __XXX___,
;     814 _X___X__,
;     815 _X___X__,
;     816 __XXX___,
;     817 ________,
;     818 __XXX___,
;     819 _X___X__,
;     820 _X___X__,
;     821 __XXXX__,
;     822 _____X__,
;     823 ____X___,
;     824 __XX____,
;     825 ________,
;     826 ________,
;     827 ________,
;     828 __XX____,
;     829 __XX____,
;     830 ________,
;     831 __XX____,
;     832 __XX____,
;     833 ________,
;     834 ________,
;     835 ________,
;     836 __XX____,
;     837 __XX____,
;     838 ________,
;     839 __XX____,
;     840 __XX____,
;     841 __X_____,
;     842 ____X___,
;     843 ___X____,
;     844 __X_____,
;     845 _X______,
;     846 __X_____,
;     847 ___X____,
;     848 ____X___,
;     849 ________,
;     850 ________,
;     851 ________,
;     852 _XXXXX__,
;     853 ________,
;     854 ________,
;     855 _XXXXX__,
;     856 ________,
;     857 ________,
;     858 __X_____,
;     859 ___X____,
;     860 ____X___,
;     861 _____X__,
;     862 ____X___,
;     863 ___X____,
;     864 __X_____,
;     865 ________,
;     866 __XXX___,
;     867 _X___X__,
;     868 _____X__,
;     869 ___XX___,
;     870 ___X____,
;     871 ________,
;     872 ___X____,
;     873 ________,
;     874 __XXX___,
;     875 _X___X__,
;     876 _X_XXX__,
;     877 _X_X_X__,
;     878 _X_XXX__,
;     879 _X______,
;     880 __XXX___,
;     881 ________,
;     882 __XXX___,
;     883 _X___X__,
;     884 _X___X__,
;     885 _X___X__,
;     886 _XXXXX__,
;     887 _X___X__,
;     888 _X___X__,
;     889 ________,
;     890 _XXXX___,
;     891 _X___X__,
;     892 _X___X__,
;     893 _XXXX___,
;     894 _X___X__,
;     895 _X___X__,
;     896 _XXXX___,
;     897 ________,
;     898 __XXX___,
;     899 _X___X__,
;     900 _X______,
;     901 _X______,
;     902 _X______,
;     903 _X___X__,
;     904 __XXX___,
;     905 ________,
;     906 _XXXX___,
;     907 _X___X__,
;     908 _X___X__,
;     909 _X___X__,
;     910 _X___X__,
;     911 _X___X__,
;     912 _XXXX___,
;     913 ________,
;     914 _XXXXX__,
;     915 _X______,
;     916 _X______,
;     917 _XXXX___,
;     918 _X______,
;     919 _X______,
;     920 _XXXXX__,
;     921 ________,
;     922 _XXXXX__,
;     923 _X______,
;     924 _X______,
;     925 _XXXX___,
;     926 _X______,
;     927 _X______,
;     928 _X______,
;     929 ________,
;     930 __XXX___,
;     931 _X___X__,
;     932 _X______,
;     933 _X_XXX__,
;     934 _X___X__,
;     935 _X___X__,
;     936 __XXXX__,
;     937 ________,
;     938 _X___X__,
;     939 _X___X__,
;     940 _X___X__,
;     941 _XXXXX__,
;     942 _X___X__,
;     943 _X___X__,
;     944 _X___X__,
;     945 ________,
;     946 __XXX___,
;     947 ___X____,
;     948 ___X____,
;     949 ___X____,
;     950 ___X____,
;     951 ___X____,
;     952 __XXX___,
;     953 ________,
;     954 _____X__,
;     955 _____X__,
;     956 _____X__,
;     957 _____X__,
;     958 _X___X__,
;     959 _X___X__,
;     960 __XXX___,
;     961 ________,
;     962 _X___X__,
;     963 _X__X___,
;     964 _X_X____,
;     965 _XX_____,
;     966 _X_X____,
;     967 _X__X___,
;     968 _X___X__,
;     969 ________,
;     970 _X______,
;     971 _X______,
;     972 _X______,
;     973 _X______,
;     974 _X______,
;     975 _X______,
;     976 _XXXXX__,
;     977 ________,
;     978 _X___X__,
;     979 _XX_XX__,
;     980 _X_X_X__,
;     981 _X___X__,
;     982 _X___X__,
;     983 _X___X__,
;     984 _X___X__,
;     985 ________,
;     986 _X___X__,
;     987 _XX__X__,
;     988 _X_X_X__,
;     989 _X__XX__,
;     990 _X___X__,
;     991 _X___X__,
;     992 _X___X__,
;     993 ________,
;     994 __XXX___,
;     995 _X___X__,
;     996 _X___X__,
;     997 _X___X__,
;     998 _X___X__,
;     999 _X___X__,
;    1000 __XXX___,
;    1001 ________,
;    1002 _XXXX___,
;    1003 _X___X__,
;    1004 _X___X__,
;    1005 _XXXX___,
;    1006 _X______,
;    1007 _X______,
;    1008 _X______,
;    1009 ________,
;    1010 __XXX___,
;    1011 _X___X__,
;    1012 _X___X__,
;    1013 _X___X__,
;    1014 _X_X_X__,
;    1015 _X__X___,
;    1016 __XX_X__,
;    1017 ________,
;    1018 _XXXX___,
;    1019 _X___X__,
;    1020 _X___X__,
;    1021 _XXXX___,
;    1022 _X__X___,
;    1023 _X___X__,
;    1024 _X___X__,
;    1025 ________,
;    1026 __XXX___,
;    1027 _X___X__,
;    1028 _X______,
;    1029 __XXX___,
;    1030 _____X__,
;    1031 _X___X__,
;    1032 __XXX___,
;    1033 ________,
;    1034 _XXXXX__,
;    1035 ___X____,
;    1036 ___X____,
;    1037 ___X____,
;    1038 ___X____,
;    1039 ___X____,
;    1040 ___X____,
;    1041 ________,
;    1042 _X___X__,
;    1043 _X___X__,
;    1044 _X___X__,
;    1045 _X___X__,
;    1046 _X___X__,
;    1047 _X___X__,
;    1048 __XXX___,
;    1049 ________,
;    1050 _X___X__,
;    1051 _X___X__,
;    1052 _X___X__,
;    1053 _X___X__,
;    1054 _X___X__,
;    1055 __X_X___,
;    1056 ___X____,
;    1057 ________,
;    1058 _X___X__,
;    1059 _X___X__,
;    1060 _X_X_X__,
;    1061 _X_X_X__,
;    1062 _X_X_X__,
;    1063 _X_X_X__,
;    1064 __X_X___,
;    1065 ________,
;    1066 _X___X__,
;    1067 _X___X__,
;    1068 __X_X___,
;    1069 ___X____,
;    1070 __X_X___,
;    1071 _X___X__,
;    1072 _X___X__,
;    1073 ________,
;    1074 _X___X__,
;    1075 _X___X__,
;    1076 _X___X__,
;    1077 __X_X___,
;    1078 ___X____,
;    1079 ___X____,
;    1080 ___X____,
;    1081 ________,
;    1082 _XXXX___,
;    1083 ____X___,
;    1084 ___X____,
;    1085 __X_____,
;    1086 _X______,
;    1087 _X______,
;    1088 _XXXX___,
;    1089 ________,
;    1090 __XXX___,
;    1091 __X_____,
;    1092 __X_____,
;    1093 __X_____,
;    1094 __X_____,
;    1095 __X_____,
;    1096 __XXX___,
;    1097 ________,
;    1098 ________,
;    1099 _X______,
;    1100 __X_____,
;    1101 ___X____,
;    1102 ____X___,
;    1103 _____X__,
;    1104 ________,
;    1105 ________,
;    1106 __XXX___,
;    1107 ____X___,
;    1108 ____X___,
;    1109 ____X___,
;    1110 ____X___,
;    1111 ____X___,
;    1112 __XXX___,
;    1113 ________,
;    1114 ___X____,
;    1115 __X_X___,
;    1116 _X___X__,
;    1117 ________,
;    1118 ________,
;    1119 ________,
;    1120 ________,
;    1121 ________,
;    1122 ________,
;    1123 ________,
;    1124 ________,
;    1125 ________,
;    1126 ________,
;    1127 ________,
;    1128 ________,
;    1129 XXXXXX__,
;    1130 __XX____,
;    1131 __XX____,
;    1132 ___X____,
;    1133 ________,
;    1134 ________,
;    1135 ________,
;    1136 ________,
;    1137 ________,
;    1138 ________,
;    1139 ________,
;    1140 __XXX___,
;    1141 _____X__,
;    1142 __XXXX__,
;    1143 _X___X__,
;    1144 __XXXX__,
;    1145 ________,
;    1146 _X______,
;    1147 _X______,
;    1148 _XXXX___,
;    1149 _X___X__,
;    1150 _X___X__,
;    1151 _X___X__,
;    1152 _XXXX___,
;    1153 ________,
;    1154 ________,
;    1155 ________,
;    1156 __XXX___,
;    1157 _X___X__,
;    1158 _X______,
;    1159 _X___X__,
;    1160 __XXX___,
;    1161 ________,
;    1162 _____X__,
;    1163 _____X__,
;    1164 __XXXX__,
;    1165 _X___X__,
;    1166 _X___X__,
;    1167 _X___X__,
;    1168 __XXXX__,
;    1169 ________,
;    1170 ________,
;    1171 ________,
;    1172 __XXX___,
;    1173 _X___X__,
;    1174 _XXXX___,
;    1175 _X______,
;    1176 __XXX___,
;    1177 ________,
;    1178 ___XX___,
;    1179 __X_____,
;    1180 __X_____,
;    1181 _XXXX___,
;    1182 __X_____,
;    1183 __X_____,
;    1184 __X_____,
;    1185 ________,
;    1186 ________,
;    1187 ________,
;    1188 __XXXX__,
;    1189 _X___X__,
;    1190 _X___X__,
;    1191 __XXXX__,
;    1192 _____X__,
;    1193 __XXX___,
;    1194 _X______,
;    1195 _X______,
;    1196 _XXX____,
;    1197 _X__X___,
;    1198 _X__X___,
;    1199 _X__X___,
;    1200 _X__X___,
;    1201 ________,
;    1202 ___X____,
;    1203 ________,
;    1204 ___X____,
;    1205 ___X____,
;    1206 ___X____,
;    1207 ___X____,
;    1208 ___XX___,
;    1209 ________,
;    1210 ____X___,
;    1211 ________,
;    1212 ___XX___,
;    1213 ____X___,
;    1214 ____X___,
;    1215 ____X___,
;    1216 _X__X___,
;    1217 __XX____,
;    1218 _X______,
;    1219 _X______,
;    1220 _X__X___,
;    1221 _X_X____,
;    1222 _XX_____,
;    1223 _X_X____,
;    1224 _X__X___,
;    1225 ________,
;    1226 ___X____,
;    1227 ___X____,
;    1228 ___X____,
;    1229 ___X____,
;    1230 ___X____,
;    1231 ___X____,
;    1232 ___XX___,
;    1233 ________,
;    1234 ________,
;    1235 ________,
;    1236 _XX_X___,
;    1237 _X_X_X__,
;    1238 _X_X_X__,
;    1239 _X___X__,
;    1240 _X___X__,
;    1241 ________,
;    1242 ________,
;    1243 ________,
;    1244 _XXX____,
;    1245 _X__X___,
;    1246 _X__X___,
;    1247 _X__X___,
;    1248 _X__X___,
;    1249 ________,
;    1250 ________,
;    1251 ________,
;    1252 __XXX___,
;    1253 _X___X__,
;    1254 _X___X__,
;    1255 _X___X__,
;    1256 __XXX___,
;    1257 ________,
;    1258 ________,
;    1259 ________,
;    1260 _XXXX___,
;    1261 _X___X__,
;    1262 _X___X__,
;    1263 _X___X__,
;    1264 _XXXX___,
;    1265 _X______,
;    1266 ________,
;    1267 ________,
;    1268 __XXXX__,
;    1269 _X___X__,
;    1270 _X___X__,
;    1271 _X___X__,
;    1272 __XXXX__,
;    1273 _____X__,
;    1274 ________,
;    1275 ________,
;    1276 _X_XX___,
;    1277 __X__X__,
;    1278 __X_____,
;    1279 __X_____,
;    1280 _XXX____,
;    1281 ________,
;    1282 ________,
;    1283 ________,
;    1284 __XXX___,
;    1285 _X______,
;    1286 __XXX___,
;    1287 _____X__,
;    1288 __XXX___,
;    1289 ________,
;    1290 ________,
;    1291 __X_____,
;    1292 _XXXX___,
;    1293 __X_____,
;    1294 __X_____,
;    1295 __X_X___,
;    1296 ___X____,
;    1297 ________,
;    1298 ________,
;    1299 ________,
;    1300 _X__X___,
;    1301 _X__X___,
;    1302 _X__X___,
;    1303 _X_XX___,
;    1304 __X_X___,
;    1305 ________,
;    1306 ________,
;    1307 ________,
;    1308 _X___X__,
;    1309 _X___X__,
;    1310 _X___X__,
;    1311 __X_X___,
;    1312 ___X____,
;    1313 ________,
;    1314 ________,
;    1315 ________,
;    1316 _X___X__,
;    1317 _X___X__,
;    1318 _X_X_X__,
;    1319 _XXXXX__,
;    1320 __X_X___,
;    1321 ________,
;    1322 ________,
;    1323 ________,
;    1324 _X__X___,
;    1325 _X__X___,
;    1326 __XX____,
;    1327 _X__X___,
;    1328 _X__X___,
;    1329 ________,
;    1330 ________,
;    1331 ________,
;    1332 _X__X___,
;    1333 _X__X___,
;    1334 _X__X___,
;    1335 __XXX___,
;    1336 ___X____,
;    1337 _XX_____,
;    1338 ________,
;    1339 ________,
;    1340 _XXXX___,
;    1341 ____X___,
;    1342 __XX____,
;    1343 _X______,
;    1344 _XXXX___,
;    1345 ________,
;    1346 ___XX___,
;    1347 __X_____,
;    1348 __X_____,
;    1349 _XX_____,
;    1350 __X_____,
;    1351 __X_____,
;    1352 ___XX___,
;    1353 ________,
;    1354 ___X____,
;    1355 ___X____,
;    1356 ___X____,
;    1357 ________,
;    1358 ___X____,
;    1359 ___X____,
;    1360 ___X____,
;    1361 ________,
;    1362 __XX____,
;    1363 ____X___,
;    1364 ____X___,
;    1365 ____XX__,
;    1366 ____X___,
;    1367 ____X___,
;    1368 __XX____,
;    1369 ________,
;    1370 __X_X___,
;    1371 _X_X____,
;    1372 ________,
;    1373 ________,
;    1374 ________,
;    1375 ________,
;    1376 ________,
;    1377 ________,
;    1378 ___X____,
;    1379 __XXX___,
;    1380 _XX_XX__,
;    1381 _X___X__,
;    1382 _X___X__,
;    1383 _XXXXX__,
;    1384 ________,
;    1385 ________
;    1386 };
;    1387 
;    1388 void lcd_msg1(type_flash char *text);
;    1389 void beeper(byte beeep);
;    1390 
;    1391 
;    1392 
;    1393 
;    1394 
;    1395 
;    1396 
;    1397 
;    1398 
;    1399 
;    1400 byte l_mask_array[8] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

	.DSEG
_l_mask_array:
	.BYTE 0x8
;    1401 
;    1402 void lcd_setpixel( short x,  short y, char pcolor) // pixel color: 1-set, 0-clear, 2-toggle
;    1403 {unsigned short byte_off;

	.CSEG
_lcd_setpixel:
;    1404 char bit_off,tmpc;
;    1405 if (x>=scr_width) return;
	RCALL __SAVELOCR4
;	x -> Y+7
;	y -> Y+5
;	pcolor -> Y+4
;	byte_off -> R16,R17
;	bit_off -> R19
;	tmpc -> R18
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0xA
	RJMP _0xA1
;    1406 if (x<0) return;
_0xA:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,0
	BRGE _0xB
	RJMP _0xA1
;    1407 if (y>=scr_height) return;
_0xB:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0xC
	RJMP _0xA1
;    1408 if (y<0) return;
_0xC:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,0
	BRGE _0xD
	RJMP _0xA1
;    1409 byte_off=(x>>3)+y*(scr_width>>3);
_0xD:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RCALL __ASRW3
	MOVW R26,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	RCALL __LSLW3
	ADD  R30,R26
	ADC  R31,R27
	MOVW R16,R30
;    1410 bit_off=x & 7;
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	MOV  R19,R30
;    1411 tmpc=ahi_buffer[byte_off];
	LDI  R26,LOW(_ahi_buffer)
	LDI  R27,HIGH(_ahi_buffer)
	ADD  R26,R16
	ADC  R27,R17
	LD   R18,X
;    1412 if (pcolor==1) tmpc |= (l_mask_array[bit_off]);
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRNE _0xE
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_l_mask_array)
	SBCI R31,HIGH(-_l_mask_array)
	LD   R30,Z
	OR   R18,R30
;    1413 if (pcolor==0) tmpc &= (l_mask_array[bit_off]) ^ 255 ;
_0xE:
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0xF
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_l_mask_array)
	SBCI R31,HIGH(-_l_mask_array)
	LD   R30,Z
	LDI  R26,LOW(255)
	EOR  R30,R26
	AND  R18,R30
;    1414 if (pcolor==2) tmpc ^= (l_mask_array[bit_off]);
_0xF:
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BRNE _0x10
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_l_mask_array)
	SBCI R31,HIGH(-_l_mask_array)
	LD   R30,Z
	EOR  R18,R30
;    1415 ahi_buffer[byte_off]=tmpc;
_0x10:
	MOVW R30,R16
	SUBI R30,LOW(-_ahi_buffer)
	SBCI R31,HIGH(-_ahi_buffer)
	ST   Z,R18
;    1416 return;}
_0xA1:
	RCALL __LOADLOCR4
	ADIW R28,9
	RET
;    1417 
;    1418 /*
;    1419 flash unsigned char a2o[256] = {
;    1420 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
;    1421 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
;    1422 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
;    1423 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
;    1424 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F,
;    1425 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,
;    1426 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F,
;    1427 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F,
;    1428 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
;    1429 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
;    1430 0xFF, 0xF6, 0xF7, 0x20, 0xFD, 0xF2, 0x7C, 0x20, 0xF0, 0x20, 0xF4, 0x20, 0x20, 0x20, 0x20, 0xF8,
;    1431 0xF8, 0xB1, 0xF6, 0xF7, 0xF3, 0x20, 0x20, 0xFA, 0xF1, 0xFC, 0xF5, 0x20, 0x20, 0x20, 0x20, 0xF9,
;    1432 0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F,
;    1433 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9A, 0xDB, 0x9C, 0x9D, 0x9E, 0x9F,
;    1434 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF,
;    1435 0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF
;    1436 };
;    1437 */
;    1438 /*static unsigned char o2a[256] = {
;    1439 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
;    1440 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
;    1441 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
;    1442 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
;    1443 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F,
;    1444 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,
;    1445 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F,
;    1446 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F,
;    1447 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF,
;    1448 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF,
;    1449 0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF,
;    1450 0x2D, 0x2D, 0x2D, 0x7C, 0x2B, 0x7C, 0x7C, 0x2D, 0x2D, 0x7C, 0x7C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D,
;    1451 0x2D, 0x2B, 0x2D, 0x2B, 0x2D, 0x2B, 0x7C, 0x7C, 0x2D, 0x2D, 0x7C, 0x2D, 0x7C, 0x3D, 0x2B, 0x7C,
;    1452 0x7C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2B, 0x2B, 0x2D, 0x2D, 0x2D, 0x2D, 0x7C, 0x7C, 0x2D,
;    1453 0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF,
;    1454 0xA8, 0xB8, 0xA5, 0xB4, 0xAA, 0xBA, 0xB2, 0xB3, 0xAF, 0xBF, 0xB7, 0xFB, 0xB9, 0xA4, 0xFE, 0xA0
;    1455 };
;    1456   */
;    1457 
;    1458 
;    1459 /*
;    1460 void lcd_oemchar (byte glyph1) // put a char to the position. Color 0-normal, 1-inverted, 2-XOR
;    1461 {unsigned short byte_off;
;    1462 long bit_off;
;    1463 byte bit_rem;
;    1464 unsigned char tmpc,tmpz,icnt;
;    1465 byte glyph;
;    1466 unsigned short pchr;
;    1467 glyph=a2o[glyph1];
;    1468 
;    1469 bit_off=char_x+char_y*scr_width;
;    1470 bit_rem=bit_off&7; // 00000001
;    1471 if (bit_rem==0)
;    1472 {
;    1473         byte_off=bit_off>>3;
;    1474         pchr=(short)glyph*font_height;
;    1475                 for (icnt=0;icnt<font_height;icnt++)
;    1476                         {tmpc=b2i[font_set[pchr]]; pchr++;
;    1477                         tmpc |= ahi_buffer[byte_off];
;    1478                         ahi_buffer[byte_off]=tmpc;
;    1479                         byte_off+=scr_width>>3; // columns
;    1480                         }
;    1481 
;    1482 
;    1483 
;    1484 }
;    1485 else // 2 bytes split in halves
;    1486 {
;    1487         byte_off=bit_off>>3;
;    1488         pchr=(short)glyph*font_height;
;    1489                 for (icnt=0;icnt<font_height;icnt++)
;    1490                         {tmpc=b2i[font_set[pchr]]; pchr++;
;    1491                         tmpz=tmpc<<bit_rem;
;    1492                         tmpz |= ahi_buffer[byte_off];
;    1493                         ahi_buffer[byte_off]=tmpz;
;    1494                         tmpz=tmpc>>(8-bit_rem);
;    1495                         tmpz |= ahi_buffer[byte_off+1];
;    1496                         ahi_buffer[byte_off+1]=tmpz;
;    1497 
;    1498                         byte_off+=scr_width>>3; // columns
;    1499                         }
;    1500 
;    1501 
;    1502 
;    1503 
;    1504 
;    1505 }
;    1506 char_x+=font_width;
;    1507 return;}
;    1508 */
;    1509 
;    1510 
;    1511  /*
;    1512 void lcd_print(type_flash char *text) // curcol,currow,mode 0-normal,1-inverted,2-XOR
;    1513 {char disp=0;
;    1514 char tmpc;
;    1515 while(*(text+disp)!=0)
;    1516 {tmpc=*(text+disp);
;    1517 
;    1518 lcd_oemchar(tmpc); // inc posn
;    1519 disp++;
;    1520 }
;    1521 return;}
;    1522    */
;    1523 
;    1524 void lcd_line(  short x1,  short y1,  short x2,  short y2,   short mode )
;    1525 {
_lcd_line:
;    1526     int deltaX = abs(x2 - x1);
;    1527     int deltaY = abs(y2 - y1);
;    1528     int signX = x1 < x2 ? 1 : -1;
;    1529     int signY = y1 < y2 ? 1 : -1;
;    1530     int error = deltaX - deltaY;
;    1531     int error2;
;    1532 
;    1533     for (;;)
	SBIW R28,6
	RCALL __SAVELOCR6
;	x1 -> Y+20
;	y1 -> Y+18
;	x2 -> Y+16
;	y2 -> Y+14
;	mode -> Y+12
;	deltaX -> R16,R17
;	deltaY -> R18,R19
;	signX -> R20,R21
;	signY -> Y+10
;	error -> Y+8
;	error2 -> Y+6
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RCALL _abs
	MOVW R16,R30
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RCALL _abs
	MOVW R18,R30
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x11
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x12
_0x11:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0x12:
	MOVW R20,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x14
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x15
_0x14:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0x15:
	STD  Y+10,R30
	STD  Y+10+1,R31
	MOVW R30,R16
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x18:
;    1534     {
;    1535         lcd_setpixel(x1, y1,mode);
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+16
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1536 
;    1537         if(x1 == x2 && y1 == y2)
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x1B
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
;    1538             break;
	RJMP _0x19
;    1539 
;    1540         error2 = error * 2;
_0x1A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LSL  R30
	ROL  R31
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1541 
;    1542         if(error2 > -deltaY)
	MOVW R30,R18
	RCALL __ANEGW1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x1D
;    1543         {
;    1544             error -= deltaY;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1545             x1 += signX;
	MOVW R30,R20
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+20,R30
	STD  Y+20+1,R31
;    1546         }
;    1547 
;    1548         if(error2 < deltaX)
_0x1D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R16
	CPC  R27,R17
	BRGE _0x1E
;    1549         {
;    1550             error += deltaX;
	MOVW R30,R16
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1551             y1 += signY;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+18,R30
	STD  Y+18+1,R31
;    1552         }
;    1553     }
_0x1E:
	RJMP _0x18
_0x19:
;    1554 }
	RCALL __LOADLOCR6
	ADIW R28,22
	RET
;    1555 
;    1556 void lcd_circle(short xCenter, short yCenter, short radius, short mode)
;    1557  {  short tSwitch, y, x = 0;
_lcd_circle:
;    1558     short d;
;    1559    d = yCenter - xCenter;
	SBIW R28,2
	RCALL __SAVELOCR6
;	xCenter -> Y+14
;	yCenter -> Y+12
;	radius -> Y+10
;	mode -> Y+8
;	tSwitch -> R16,R17
;	y -> R18,R19
;	x -> R20,R21
;	d -> Y+6
	LDI  R20,0
	LDI  R21,0
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1560    y = radius;
	__GETWRS 18,19,10
;    1561    tSwitch = 3 - 2 * radius;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LSL  R30
	ROL  R31
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	SUB  R26,R30
	SBC  R27,R31
	MOVW R16,R26
;    1562    while (x <= y)
_0x1F:
	__CPWRR 18,19,20,21
	BRGE PC+2
	RJMP _0x21
;    1563     { lcd_setpixel(xCenter + x, yCenter + y, mode);
	MOVW R30,R20
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1564       lcd_setpixel(xCenter + x, yCenter - y, mode);
	MOVW R30,R20
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R18
	SBC  R31,R19
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1565      lcd_setpixel(xCenter - x, yCenter + y, mode);
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1566       lcd_setpixel(xCenter - x, yCenter - y, mode);
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R18
	SBC  R31,R19
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1567       lcd_setpixel(yCenter + y - d, yCenter + x, mode);
	MOVW R30,R18
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	MOVW R30,R20
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1568       lcd_setpixel(yCenter + y - d, yCenter - x, mode);
	MOVW R30,R18
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1569       lcd_setpixel(yCenter - y - d, yCenter + x, mode);
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R18
	SBC  R31,R19
	MOVW R26,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	MOVW R30,R20
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1570       lcd_setpixel(yCenter - y - d, yCenter - x, mode);
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R18
	SBC  R31,R19
	MOVW R26,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R20
	SBC  R31,R21
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1571       if (tSwitch < 0)  tSwitch += (4 * x + 6);  else  { tSwitch += (4 * (x - y) + 10); y--; }
	SUBI R16,0
	SBCI R17,0
	BRGE _0x22
	MOVW R30,R20
	RCALL __LSLW2
	ADIW R30,6
	__ADDWRR 16,17,30,31
	RJMP _0x23
_0x22:
	MOVW R30,R20
	SUB  R30,R18
	SBC  R31,R19
	RCALL __LSLW2
	ADIW R30,10
	__ADDWRR 16,17,30,31
	__SUBWRN 18,19,1
_0x23:
;    1572       x++;
	__ADDWRN 20,21,1
;    1573     }
	RJMP _0x1F
_0x21:
;    1574  }
	RCALL __LOADLOCR6
	ADIW R28,16
	RET
;    1575 
;    1576  // tbitmap
;    1577 
;    1578 
;    1579 
;    1580 // #include "pix.c"
;    1581 /*void lcd_bmp(type_flash char *pix, char y, char x, char pmode) // mode 0-norm,1-inv,2-xor
;    1582 // picture format: width,height,[bitmap]
;    1583 {unsigned short tmc,x2,y2,baseoff;
;    1584 char tmw,tmh,tmpc;
;    1585 baseoff=x+(short)y*40*font_height; // base offset for x and y
;    1586 tmw=(*pix)>>3; //width in bytes
;    1587 tmh=*(pix+1) ;//height
;    1588 tmc=2;
;    1589 for (y2=0;y2<tmh;y2++)
;    1590 {for (x2=0;x2<tmw;x2++)
;    1591      {
;    1592 tmpc= *(pix+tmc);
;    1593 if (pmode==2) tmpc ^= lcd_getb(0,baseoff);
;    1594 if (pmode==1) tmpc ^=255;
;    1595 lcd_putb(0,baseoff, tmpc);
;    1596 baseoff++;
;    1597 tmc++;
;    1598      }
;    1599 baseoff+=40-tmw;
;    1600  }
;    1601 return;} */
;    1602 /*
;    1603 void lcd_drawbox(unsigned short x,unsigned short y,unsigned short dispx,unsigned short dispy,char pmode)
;    1604 {
;    1605 lcd_line(x,y,x,y+dispy,pmode);
;    1606 lcd_line(x,y,x+dispx,y,pmode);
;    1607 lcd_line(x+dispx,y+dispy,x,y+dispy,pmode);
;    1608 lcd_line(x+dispx,y+dispy,x+dispx,y,pmode);
;    1609 return;}
;    1610 
;    1611 
;    1612 void lcd_fillbox(unsigned short x,unsigned short y,unsigned short dispx,unsigned short dispy,char pmode)
;    1613 {
;    1614 unsigned short i,j;
;    1615 i=y;j=y+dispy;
;    1616 while (i<j)
;    1617 {lcd_line(x,i,x+dispx,i,pmode);
;    1618 i++;}
;    1619 return;
;    1620 
;    1621 }
;    1622 */
;    1623 void intos(int x,long num,byte dig,byte zeros,byte zpt) // pmode 5: into buffer
;    1624 {
_intos:
;    1625 byte cpush,leadz=0;
;    1626 unsigned short div;
;    1627 unsigned long rem;
;    1628 
;    1629 if (num<0){num=-num;line_buffer[x++]='-';}
	SBIW R28,4
	RCALL __SAVELOCR4
;	x -> Y+15
;	num -> Y+11
;	dig -> Y+10
;	zeros -> Y+9
;	zpt -> Y+8
;	cpush -> R17
;	leadz -> R16
;	div -> R18,R19
;	rem -> Y+4
	LDI  R16,0
	__GETD2S 11
	RCALL __CPD20
	BRGE _0x24
	__GETD1S 11
	RCALL __ANEGD1
	__PUTD1S 11
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(45)
	RJMP _0xA2
;    1630 else line_buffer[x++]=' ';
_0x24:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(32)
_0xA2:
	STD  Z+0,R26
;    1631 
;    1632 
;    1633 
;    1634 rem=num;
	__GETD1S 11
	__PUTD1S 4
;    1635 if (dig>=7)
	LDD  R26,Y+10
	CPI  R26,LOW(0x7)
	BRSH PC+2
	RJMP _0x26
;    1636 {
;    1637 div=rem/1000000;
	__GETD2S 4
	__GETD1N 0xF4240
	RCALL __DIVD21U
	MOVW R18,R30
;    1638 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x27
	LDI  R16,LOW(1)
;    1639 rem-=1000000*div;
_0x27:
	MOVW R30,R18
	__GETD2N 0xF4240
	CLR  R22
	CLR  R23
	RCALL __MULD12
	__GETD2S 4
	RCALL __SUBD21
	__PUTD2S 4
;    1640 if (div | zeros| leadz|(zpt==6)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(6)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x28
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1641 }
_0x28:
;    1642 if (zpt==6) line_buffer[x++]='.';
_0x26:
	LDD  R26,Y+8
	CPI  R26,LOW(0x6)
	BRNE _0x29
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1643 if (dig>=6)
_0x29:
	LDD  R26,Y+10
	CPI  R26,LOW(0x6)
	BRSH PC+2
	RJMP _0x2A
;    1644 {
;    1645 div=rem/100000;
	__GETD2S 4
	__GETD1N 0x186A0
	RCALL __DIVD21U
	MOVW R18,R30
;    1646 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x2B
	LDI  R16,LOW(1)
;    1647 rem-=100000*div;
_0x2B:
	MOVW R30,R18
	__GETD2N 0x186A0
	CLR  R22
	CLR  R23
	RCALL __MULD12
	__GETD2S 4
	RCALL __SUBD21
	__PUTD2S 4
;    1648 if (div | zeros| leadz|(zpt==5)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(5)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x2C
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1649 }
_0x2C:
;    1650 if (zpt==5) line_buffer[x++]='.';
_0x2A:
	LDD  R26,Y+8
	CPI  R26,LOW(0x5)
	BRNE _0x2D
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1651 if (dig>=5)
_0x2D:
	LDD  R26,Y+10
	CPI  R26,LOW(0x5)
	BRSH PC+2
	RJMP _0x2E
;    1652 {
;    1653 div=rem/10000;
	__GETD2S 4
	__GETD1N 0x2710
	RCALL __DIVD21U
	MOVW R18,R30
;    1654 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x2F
	LDI  R16,LOW(1)
;    1655 rem-=10000*div;
_0x2F:
	MOVW R30,R18
	LDI  R26,LOW(10000)
	LDI  R27,HIGH(10000)
	RCALL __MULW12U
	__GETD2S 4
	CLR  R22
	CLR  R23
	RCALL __SUBD21
	__PUTD2S 4
;    1656 if (div | zeros | leadz|(zpt==4)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(4)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1657 }
_0x30:
;    1658 if (zpt==4) line_buffer[x++]='.';
_0x2E:
	LDD  R26,Y+8
	CPI  R26,LOW(0x4)
	BRNE _0x31
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1659 if (dig>=4)
_0x31:
	LDD  R26,Y+10
	CPI  R26,LOW(0x4)
	BRSH PC+2
	RJMP _0x32
;    1660 {
;    1661 div=rem/1000;
	__GETD2S 4
	__GETD1N 0x3E8
	RCALL __DIVD21U
	MOVW R18,R30
;    1662 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x33
	LDI  R16,LOW(1)
;    1663 rem-=1000*div;
_0x33:
	MOVW R30,R18
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL __MULW12U
	__GETD2S 4
	CLR  R22
	CLR  R23
	RCALL __SUBD21
	__PUTD2S 4
;    1664 if (div | zeros| leadz|(zpt==3)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(3)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x34
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1665 }
_0x34:
;    1666 if (zpt==3) line_buffer[x++]='.';
_0x32:
	LDD  R26,Y+8
	CPI  R26,LOW(0x3)
	BRNE _0x35
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1667 if (dig>=3)
_0x35:
	LDD  R26,Y+10
	CPI  R26,LOW(0x3)
	BRSH PC+2
	RJMP _0x36
;    1668 {
;    1669 div=rem/100;
	__GETD2S 4
	__GETD1N 0x64
	RCALL __DIVD21U
	MOVW R18,R30
;    1670 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x37
	LDI  R16,LOW(1)
;    1671 rem-=100*div;
_0x37:
	__MULBNWRU 18,19,100
	__GETD2S 4
	CLR  R22
	CLR  R23
	RCALL __SUBD21
	__PUTD2S 4
;    1672 if (div | zeros| leadz|(zpt==2)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(2)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x38
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1673 }
_0x38:
;    1674 if (zpt==2) line_buffer[x++]='.';
_0x36:
	LDD  R26,Y+8
	CPI  R26,LOW(0x2)
	BRNE _0x39
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1675 if (dig>=2)
_0x39:
	LDD  R26,Y+10
	CPI  R26,LOW(0x2)
	BRSH PC+2
	RJMP _0x3A
;    1676 {
;    1677 div=rem/10;
	__GETD2S 4
	__GETD1N 0xA
	RCALL __DIVD21U
	MOVW R18,R30
;    1678 if (div) leadz=1;
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x3B
	LDI  R16,LOW(1)
;    1679 rem-=10*div;
_0x3B:
	__MULBNWRU 18,19,10
	__GETD2S 4
	CLR  R22
	CLR  R23
	RCALL __SUBD21
	__PUTD2S 4
;    1680 if (div | zeros| leadz|(zpt==1)) {line_buffer[x++]=(div+0x30);}
	LDD  R30,Y+9
	LDI  R31,0
	OR   R30,R18
	OR   R31,R19
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R0,R30
	LDD  R26,Y+8
	LDI  R30,LOW(1)
	RCALL __EQB12
	LDI  R31,0
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	BREQ _0x3C
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	MOVW R30,R18
	ADIW R30,48
	ST   X,R30
;    1681 }
_0x3C:
;    1682 if (zpt==1) line_buffer[x++]='.';
_0x3A:
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BRNE _0x3D
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	LDI  R26,LOW(46)
	STD  Z+0,R26
;    1683 
;    1684 line_buffer[x++]=((byte)rem+0x30);
_0x3D:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R26,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(48)
	ST   X,R30
;    1685 }
	RCALL __LOADLOCR4
	ADIW R28,17
	RET
;    1686 
;    1687 
;    1688 
;    1689 /*
;    1690 void lcd_arc(void) //  :)
;    1691 {
;    1692 signed int bx[30]={20,20,70,140,100,164,20,34,85,100,164,20,20,100,164,20,34,85,130,20,70,140,20,34,85,130,130,20,70,140};
;    1693 signed int by[30]={100,164,50,100,164,20,100,164,20,34,185,30,120,70,40,50,120,70,40,20,34,185,30,34,185,30,120,70,40,50};
;    1694 signed int br[30]={3,7,4,3,7,4,3,8,6,8,6,9,3,8,3,7,4,3,8,6,5,3,8,3,9,5,9,5,3,8};
;    1695 signed int dbx[30]={1,-1,2,-1,2,1,-1,3,-1,1,3,-1,2,3,-1,3,1,-2,1,-2,-1,-2,-1,-2,1,1,2,-2,-1,-3};
;    1696 signed int dby[30]={-5,-4,-2,-4,-2,-3,-3,-2,-3,-2,-3,-4,-2,-2,-2,-3,-3,-2,-2,-2,-4,-3,-2,-2,-3,-4,-4,-2,-2,-2};
;    1697 byte ccnt;
;    1698 int bxt,byt;
;    1699 
;    1700 long k;
;    1701 lcd_cls();
;    1702 
;    1703 ccnt=25;while (ccnt){lcd_circle(bx[ccnt],by[ccnt],br[ccnt],1);ccnt--;}
;    1704 arc_lp01:
;    1705 ccnt=25;while (ccnt){
;    1706 lcd_circle(bx[ccnt],by[ccnt],br[ccnt],0);
;    1707 bxt=bx[ccnt]+dbx[ccnt];
;    1708 byt=by[ccnt]+dby[ccnt];
;    1709 if ((bxt>320)|(bxt<0)) dbx[ccnt]=-dbx[ccnt];
;    1710 if ((byt>240)|(byt<0)) by[ccnt]=240;//dby[ccnt]=-dby[ccnt];
;    1711 bx[ccnt]+=dbx[ccnt];
;    1712 by[ccnt]+=dby[ccnt];
;    1713 lcd_circle(bx[ccnt],by[ccnt],br[ccnt],1);
;    1714 ccnt--;}
;    1715 curcol=5;
;    1716 currow=10;
;    1717 lcd_print(" .   ",0);
;    1718 curcol=13;
;    1719 currow=11;
;    1720 keyscan();
;    1721 if (keybuf<6) return;//lcd_print("",0);
;    1722 k=10;
;    1723 while (k)
;    1724 {k--;}
;    1725 
;    1726 goto arc_lp01;
;    1727 }
;    1728 
;    1729  */
;    1730 //void lcd_dispframe
;    1731 
;    1732 
;    1733 
;    1734 
;    1735 
;    1736 
;    1737 // Timer 2 overflow interrupt service routine // each 80 us, 2MHz tick
;    1738 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;    1739 {
_timer2_ovf_isr:
	ST   -Y,R30
;    1740 // Place your code here
;    1741 	TCNT2=177; // reset 80us interrupt
	LDI  R30,LOW(177)
	STS  178,R30
;    1742 	//if (UCSR0A & (1<<RXC0)) MsgHandler(UDR0); //poll the serial port
;    1743 
;    1744 }
	LD   R30,Y+
	RETI
;    1745 
;    1746 // Declare your global variables here
;    1747 int xx;
;    1748 //==================================================
;    1749 
;    1750 void lcd_cls(void)
;    1751 {for (xx=0;xx<511;xx++)
_lcd_cls:
	CLR  R10
	CLR  R11
_0x3F:
	LDI  R30,LOW(511)
	LDI  R31,HIGH(511)
	CP   R10,R30
	CPC  R11,R31
	BRGE _0x40
;    1752 ahi_buffer[xx]=0x0;
	LDI  R26,LOW(_ahi_buffer)
	LDI  R27,HIGH(_ahi_buffer)
	ADD  R26,R10
	ADC  R27,R11
	LDI  R30,LOW(0)
	ST   X,R30
;    1753 for (xx=0;xx<80;xx++)
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
	RJMP _0x3F
_0x40:
	CLR  R10
	CLR  R11
_0x42:
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	CP   R10,R30
	CPC  R11,R31
	BRGE _0x43
;    1754 line_buffer[xx]=0x0;
	LDI  R26,LOW(_line_buffer)
	LDI  R27,HIGH(_line_buffer)
	ADD  R26,R10
	ADC  R27,R11
	LDI  R30,LOW(0)
	ST   X,R30
;    1755 }
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
	RJMP _0x42
_0x43:
	RET
;    1756  //==================================================
;    1757 
;    1758 void print(int pos,flash char *text)
;    1759 {
_print:
;    1760 int disp=0;
;    1761 while(*(text+disp)!=0)
	RCALL __SAVELOCR2
;	pos -> Y+4
;	*text -> Y+2
;	disp -> R16,R17
	LDI  R16,0
	LDI  R17,0
_0x44:
	MOVW R30,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x46
;    1762 {line_buffer[pos+disp]=*(text+disp);
	MOVW R30,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_line_buffer)
	SBCI R31,HIGH(-_line_buffer)
	MOVW R0,R30
	MOVW R30,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
;    1763 disp++;}
	__ADDWRN 16,17,1
	RJMP _0x44
_0x46:
;    1764 }
	RCALL __LOADLOCR2
	ADIW R28,6
	RET
;    1765 //==================================================
;    1766 
;    1767 void draw_homebird(int hdg)
;    1768 {
_draw_homebird:
;    1769 char j; // position from 0 to 63
;    1770 if(hdg>179) hdg=hdg-360;
	ST   -Y,R17
;	hdg -> Y+1
;	j -> R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CPI  R26,LOW(0xB4)
	LDI  R30,HIGH(0xB4)
	CPC  R27,R30
	BRLT _0x47
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SUBI R30,LOW(360)
	SBCI R31,HIGH(360)
	STD  Y+1,R30
	STD  Y+1+1,R31
;    1771 j=32-((hdg)*64)/360;
_0x47:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RCALL __LSLW2
	RCALL __LSLW4
	MOVW R26,R30
	LDI  R30,LOW(360)
	LDI  R31,HIGH(360)
	RCALL __DIVW21
	LDI  R26,LOW(32)
	LDI  R27,HIGH(32)
	RCALL __SWAPW12
	SUB  R30,R26
	MOV  R17,R30
;    1772 
;    1773        // j=hdg;
;    1774  // central pixel
;    1775  lcd_setpixel(j,3,1);
	MOV  R30,R17
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1776  lcd_setpixel(j+1,4,1);
	MOV  R30,R17
	SUBI R30,-LOW(1)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1777  lcd_setpixel(j-1,4,1);
	MOV  R30,R17
	SUBI R30,LOW(1)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1778  lcd_setpixel(j+2,5,1);
	MOV  R30,R17
	SUBI R30,-LOW(2)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1779  lcd_setpixel(j-2,5,1);
	MOV  R30,R17
	SUBI R30,LOW(2)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1780 }
	LDD  R17,Y+0
	RJMP _0xA0
;    1781 //==================================================
;    1782 
;    1783 void draw_pitchbird(int hdg)
;    1784 {
_draw_pitchbird:
;    1785 byte j; // position from 0 to 63
;    1786 // pitch from -31 to +31
;    1787 if (hdg< -31) hdg=-31;
	ST   -Y,R17
;	hdg -> Y+1
;	j -> R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CPI  R26,LOW(0xFFE1)
	LDI  R30,HIGH(0xFFE1)
	CPC  R27,R30
	BRGE _0x48
	LDI  R30,LOW(65505)
	LDI  R31,HIGH(65505)
	STD  Y+1,R30
	STD  Y+1+1,R31
;    1788 if (hdg> 31) hdg=31;
_0x48:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	SBIW R26,32
	BRLT _0x49
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	STD  Y+1,R30
	STD  Y+1+1,R31
;    1789  j=32+hdg;
_0x49:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,32
	MOV  R17,R30
;    1790 
;    1791  // central pixel
;    1792  lcd_setpixel(60,j,1);
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1793  lcd_setpixel(59,j+1,1);
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(1)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1794  lcd_setpixel(59,j-1,1);
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,LOW(1)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1795  lcd_setpixel(58,j+2,1);
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(2)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1796  lcd_setpixel(58,j-2,1);
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,LOW(2)
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1797 }
	LDD  R17,Y+0
_0xA0:
	ADIW R28,3
	RET
;    1798 //==================================================
;    1799 void draw_ahiline(int roll)
;    1800 {float sinr,cosr;
_draw_ahiline:
;    1801 // line length 20
;    1802 sinr=sin(roll*0.03488);
	SBIW R28,8
;	roll -> Y+8
;	sinr -> Y+4
;	cosr -> Y+0
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL __CWD1
	RCALL __CDF1
	__GETD2N 0x3D0EDE55
	RCALL __MULF12
	RCALL __PUTPARD1
	RCALL _sin
	__PUTD1S 4
;    1803 cosr=cos(roll*0.03488);
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL __CWD1
	RCALL __CDF1
	__GETD2N 0x3D0EDE55
	RCALL __MULF12
	RCALL __PUTPARD1
	RCALL _cos
	__PUTD1S 0
;    1804 lcd_line(32-20*cosr,32+20*sinr,32+20*cosr,32-20*sinr,1);
	__GETD2N 0x41A00000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 6
	__GETD2N 0x41A00000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __ADDF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 4
	__GETD2N 0x41A00000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __ADDF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 10
	__GETD2N 0x41A00000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_line
;    1805 lcd_line(32,32,32-8*sinr,32-8*cosr,1);
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 8
	__GETD2N 0x41000000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 6
	__GETD2N 0x41000000
	RCALL __MULF12
	__GETD2N 0x42000000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_line
;    1806 }
	ADIW R28,10
	RET
;    1807 
;    1808 #define ADC_VREF_TYPE 0x40
;    1809 
;    1810 void display_vbat(void)
;    1811 { int jj;
_display_vbat:
;    1812 ADMUX=1 | (ADC_VREF_TYPE & 0xff);
	RCALL __SAVELOCR2
;	jj -> R16,R17
	LDI  R30,LOW(65)
	STS  124,R30
;    1813 // Start the AD conversion
;    1814 ADCSRA|=0x40;
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
;    1815 // Wait for the AD conversion to complete
;    1816 while ((ADCSRA & 0x10)==0);
_0x4A:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0x4A
;    1817 ADCSRA|=0x10;
	LDS  R30,122
	ORI  R30,0x10
	STS  122,R30
;    1818 
;    1819 jj=ADCW;
	__GETWRMN 16,17,0,120
;    1820 jj=jj*3;
	MOVW R26,R16
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL __MULW12
	MOVW R16,R30
;    1821 intos(0,jj,4,0,2); // print battery voltage (5 digs)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _intos
;    1822 print(6,"V");
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print
;    1823 
;    1824 
;    1825 
;    1826 
;    1827 
;    1828 }
	RCALL __LOADLOCR2P
	RET
;    1829 
;    1830 // process rx commands
;    1831 
;    1832 //==================================================
;    1833 
;    1834 byte statZ=0;
;    1835 
;    1836 byte syncro=0xcb,pkt_ctr=0,pkt_type=0;

	.DSEG
_pkt_type:
	.BYTE 0x1
;    1837 byte rx_buf[11],pak_buf0[11],pak_buf1[11],pak_buf2[11];
_rx_buf:
	.BYTE 0xB
_pak_buf0:
	.BYTE 0xB
_pak_buf1:
	.BYTE 0xB
_pak_buf2:
	.BYTE 0xB
;    1838 byte icnt,tmpr;
_icnt:
	.BYTE 0x1
_tmpr:
	.BYTE 0x1
;    1839 void receive_rx(void)
;    1840 {

	.CSEG
_receive_rx:
;    1841 /*buffer format:
;    1842 0-sync word changed (0xcb, 0x34)
;    1843 1  packet type (0 - ahi,bat,cur,mah, 1 - nav, 2 - maintenance
;    1844 2       0               1               2
;    1845 3       roll            gpslat1         gpsSPD
;    1846 4       pitch           gpslat2         gpsALTH
;    1847 5       homeH           gpslat3         gpaALTL
;    1848 6       homeL           gpslat4         gpsDISH
;    1849 7       control_mode    gpslon1         gpsDISL
;    1850 8       BATl            gpslon2         status
;    1851 9       Ih              gpslon3         config
;    1852 10      IL (up 80.0A)   gpslon4         emerg
;    1853 
;    1854 
;    1855 ==
;    1856 status:
;    1857 0..3
;    1858         0-Manual
;    1859 */
;    1860 
;    1861 // this routine is called when received 1 byte
;    1862 // 11 bytes length
;    1863 
;    1864 tmpr=UDR0;
	LDS  R30,198
	STS  _tmpr,R30
;    1865 statZ=tmpr;
	LDS  R8,_tmpr
;    1866         switch (pkt_type)
	LDS  R30,_pkt_type
;    1867         {case 0: pak_buf0[pkt_ctr]=tmpr;break;
	CPI  R30,0
	BRNE _0x51
	MOV  R30,R12
	LDI  R31,0
	SUBI R30,LOW(-_pak_buf0)
	SBCI R31,HIGH(-_pak_buf0)
	RJMP _0xA3
;    1868          case 1: pak_buf1[pkt_ctr]=tmpr;break;
_0x51:
	CPI  R30,LOW(0x1)
	BRNE _0x52
	MOV  R30,R12
	LDI  R31,0
	SUBI R30,LOW(-_pak_buf1)
	SBCI R31,HIGH(-_pak_buf1)
	RJMP _0xA3
;    1869          case 2: pak_buf2[pkt_ctr]=tmpr;break;
_0x52:
	CPI  R30,LOW(0x2)
	BRNE _0x50
	MOV  R30,R12
	LDI  R31,0
	SUBI R30,LOW(-_pak_buf2)
	SBCI R31,HIGH(-_pak_buf2)
_0xA3:
	LDS  R26,_tmpr
	STD  Z+0,R26
;    1870         }
_0x50:
;    1871 if (pkt_ctr==0) //first byte received
	TST  R12
	BRNE _0x54
;    1872         {if (tmpr==syncro) {pkt_ctr++;syncro^=255;}}
	LDS  R26,_tmpr
	CP   R13,R26
	BRNE _0x55
	INC  R12
	LDI  R30,LOW(255)
	EOR  R13,R30
_0x55:
;    1873                 //else dont increase
;    1874 else pkt_ctr++; // non-first byte received
	RJMP _0x56
_0x54:
	INC  R12
;    1875 if(pkt_ctr==2) pkt_type=tmpr;
_0x56:
	LDI  R30,LOW(2)
	CP   R30,R12
	BRNE _0x57
	LDS  R30,_tmpr
	STS  _pkt_type,R30
;    1876 if (pkt_ctr==11) pkt_ctr=0; // end of packet
_0x57:
	LDI  R30,LOW(11)
	CP   R30,R12
	BRNE _0x58
	CLR  R12
;    1877 
;    1878 }
_0x58:
	RET
;    1879 
;    1880 //==================================================
;    1881 // graphic variables
;    1882 signed char v_pitch=0,v_roll=0;

	.DSEG
_v_pitch:
	.BYTE 0x1
_v_roll:
	.BYTE 0x1
;    1883 signed int v_home=0;
_v_home:
	.BYTE 0x2
;    1884 //==================================================
;    1885 
;    1886 void process0(void) // process the packet0
;    1887 {

	.CSEG
_process0:
;    1888 /*
;    1889 0-sync word changed (0xcb, 0x34)
;    1890 1  packet type (0 - ahi,bat,cur,mah, 1 - nav, 2 - maintenance
;    1891 2       0
;    1892 3       roll
;    1893 4       pitch
;    1894 5       homeH
;    1895 6       homeL
;    1896 7       control_mode
;    1897 8       0
;    1898 9       Ih
;    1899 10      IL (up 80.0A)
;    1900 */
;    1901 v_roll=pak_buf0[3];
	__GETB1MN _pak_buf0,3
	STS  _v_roll,R30
;    1902 v_pitch=pak_buf0[4];
	__GETB1MN _pak_buf0,4
	STS  _v_pitch,R30
;    1903 v_home=((int)pak_buf0[5]<<8)|pak_buf0[6];
	__GETBRMN 27,_pak_buf0,5
	LDI  R26,LOW(0)
	__GETB1MN _pak_buf0,6
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	STS  _v_home,R30
	STS  _v_home+1,R31
;    1904 switch(pak_buf0[7])
	__GETB1MN _pak_buf0,7
;    1905         {case 0: print(30,"MANUAL");break;
	CPI  R30,0
	BRNE _0x5C
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,2
	RJMP _0xA4
;    1906          case 1: print(30,"CIRCLE");break;
_0x5C:
	CPI  R30,LOW(0x1)
	BRNE _0x5D
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,9
	RJMP _0xA4
;    1907         case 2: print(30,"STABILIZE");break;
_0x5D:
	CPI  R30,LOW(0x2)
	BRNE _0x5E
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,16
	RJMP _0xA4
;    1908         case 5: print(30,"WIRE A");break;
_0x5E:
	CPI  R30,LOW(0x5)
	BRNE _0x5F
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,26
	RJMP _0xA4
;    1909         case 6: print(30,"WIRE B");break;
_0x5F:
	CPI  R30,LOW(0x6)
	BRNE _0x60
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,33
	RJMP _0xA4
;    1910         case 10: print(30,"AUTOPILOT");break;
_0x60:
	CPI  R30,LOW(0xA)
	BRNE _0x61
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,40
	RJMP _0xA4
;    1911         case 11: print(30,"RETURN");break;
_0x61:
	CPI  R30,LOW(0xB)
	BRNE _0x62
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,50
	RJMP _0xA4
;    1912         case 12: print(30,"HOLD");break;
_0x62:
	CPI  R30,LOW(0xC)
	BRNE _0x63
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,57
	RJMP _0xA4
;    1913         case 13: print(30,"TAKEOFF");break;
_0x63:
	CPI  R30,LOW(0xD)
	BRNE _0x64
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,62
	RJMP _0xA4
;    1914         case 14: print(30,"LANDING");break;
_0x64:
	CPI  R30,LOW(0xE)
	BRNE _0x5B
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,70
_0xA4:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print
;    1915 
;    1916 
;    1917         }
_0x5B:
;    1918 
;    1919 /*
;    1920 #define MANUAL 0
;    1921 #define CIRCLE 1
;    1922 #define STABILIZE 2
;    1923 
;    1924 #define FLY_BY_WIRE_A 5
;    1925 #define FLY_BY_WIRE_B 6
;    1926 
;    1927 #define AUTO 10
;    1928 #define RTL 11
;    1929 #define LOITER 12
;    1930 #define TAKEOFF 13
;    1931 #define LAND 14
;    1932 */
;    1933 intos(40,((int)pak_buf0[9]<<8)|pak_buf0[10],3,0,1); // print current (5 digs)
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	__GETBRMN 27,_pak_buf0,9
	LDI  R26,LOW(0)
	__GETB1MN _pak_buf0,10
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _intos
;    1934 print(45,"A");
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print
;    1935 }
	RET
;    1936 //==================================================
;    1937 
;    1938 
;    1939 
;    1940 
;    1941 byte time_sec=0;

	.DSEG
_time_sec:
	.BYTE 0x1
;    1942 byte time_sec1=0;
_time_sec1:
	.BYTE 0x1
;    1943 byte time_min=0;
_time_min:
	.BYTE 0x1
;    1944 byte time_min1=0;
_time_min1:
	.BYTE 0x1
;    1945 byte time_hr=0;
_time_hr:
	.BYTE 0x1
;    1946 
;    1947 void count_time(void) // 50Hz
;    1948 {static char cnt=0;

	.CSEG
_count_time:

	.DSEG
_cnt_SE:
	.BYTE 0x1

	.CSEG
;    1949 cnt++;
	LDS  R30,_cnt_SE
	SUBI R30,-LOW(1)
	STS  _cnt_SE,R30
;    1950 if (cnt<50) return;
	LDS  R26,_cnt_SE
	CPI  R26,LOW(0x32)
	BRSH _0x66
	RET
;    1951 cnt=0;
_0x66:
	LDI  R30,LOW(0)
	STS  _cnt_SE,R30
;    1952 time_sec++; if (time_sec>9) {time_sec=0;time_sec1++;}
	LDS  R30,_time_sec
	SUBI R30,-LOW(1)
	STS  _time_sec,R30
	LDS  R26,_time_sec
	CPI  R26,LOW(0xA)
	BRLO _0x67
	LDI  R30,LOW(0)
	STS  _time_sec,R30
	LDS  R30,_time_sec1
	SUBI R30,-LOW(1)
	STS  _time_sec1,R30
;    1953 if (time_sec1>5) {time_sec1=0;time_min++;}
_0x67:
	LDS  R26,_time_sec1
	CPI  R26,LOW(0x6)
	BRLO _0x68
	LDI  R30,LOW(0)
	STS  _time_sec1,R30
	LDS  R30,_time_min
	SUBI R30,-LOW(1)
	STS  _time_min,R30
;    1954 if (time_min>9) {time_min=0;time_min1++;}
_0x68:
	LDS  R26,_time_min
	CPI  R26,LOW(0xA)
	BRLO _0x69
	LDI  R30,LOW(0)
	STS  _time_min,R30
	LDS  R30,_time_min1
	SUBI R30,-LOW(1)
	STS  _time_min1,R30
;    1955 if (time_min1>5) {time_min1=0;time_hr++;}
_0x69:
	LDS  R26,_time_min1
	CPI  R26,LOW(0x6)
	BRLO _0x6A
	LDI  R30,LOW(0)
	STS  _time_min1,R30
	LDS  R30,_time_hr
	SUBI R30,-LOW(1)
	STS  _time_hr,R30
;    1956 }
_0x6A:
	RET
;    1957 
;    1958 
;    1959 void main(void)
;    1960 {
_main:
;    1961 config();
	RCALL _config
;    1962 SMCR=1;
	LDI  R30,LOW(1)
	OUT  0x33,R30
;    1963 lcd_cls();
	RCALL _lcd_cls
;    1964 //print(0, "10.7V 5400mAh    Dis11500      AUTOPILOT");
;    1965 //print(40,"20.4A    SPD 178   ALT 2500    HDOP 1.2 ");
;    1966 print(0, "                                        ");
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,78
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print
;    1967 print(40,"                                        ");
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,78
	ST   -Y,R31
	ST   -Y,R30
	RCALL _print
;    1968 
;    1969 
;    1970 while(1)
_0x6B:
;    1971 {// loop
;    1972 
;    1973 if (flag)     //50 Hz
	TST  R7
	BRNE PC+2
	RJMP _0x6E
;    1974 {
;    1975   flag=0;
	CLR  R7
;    1976   lcd_cls();
	RCALL _lcd_cls
;    1977   count_time();
	RCALL _count_time
;    1978   line_buffer[1]++;
	__GETB1MN _line_buffer,1
	SUBI R30,-LOW(1)
	__PUTB1MN _line_buffer,1
;    1979 // draw scales and crosshair
;    1980 for(i=0;i<64;i+=4)
	CLR  R2
_0x70:
	LDI  R30,LOW(64)
	CP   R2,R30
	BRSH _0x71
;    1981 lcd_setpixel(i,0,1);
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1982 for(i=0;i<64;i+=16) // upper scale (home)
	LDI  R30,LOW(4)
	ADD  R2,R30
	RJMP _0x70
_0x71:
	CLR  R2
_0x73:
	LDI  R30,LOW(64)
	CP   R2,R30
	BRSH _0x74
;    1983 {lcd_setpixel(i,1,1);
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1984 lcd_setpixel(i,2,1);}
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
	LDI  R30,LOW(16)
	ADD  R2,R30
	RJMP _0x73
_0x74:
;    1985 
;    1986 for(i=0;i<64;i+=4) // right scale (pitch)
	CLR  R2
_0x76:
	LDI  R30,LOW(64)
	CP   R2,R30
	BRSH _0x77
;    1987 lcd_setpixel(63,i,1);
	LDI  R30,LOW(63)
	LDI  R31,HIGH(63)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1988 for(i=0;i<64;i+=16) //
	LDI  R30,LOW(4)
	ADD  R2,R30
	RJMP _0x76
_0x77:
	CLR  R2
_0x79:
	LDI  R30,LOW(64)
	CP   R2,R30
	BRSH _0x7A
;    1989 {lcd_setpixel(62,i,1);
	LDI  R30,LOW(62)
	LDI  R31,HIGH(62)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
;    1990 lcd_setpixel(61,i,1);}
	LDI  R30,LOW(61)
	LDI  R31,HIGH(61)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_setpixel
	LDI  R30,LOW(16)
	ADD  R2,R30
	RJMP _0x79
_0x7A:
;    1991 
;    1992 // home bird
;    1993 draw_homebird(v_home);
	LDS  R30,_v_home
	LDS  R31,_v_home+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _draw_homebird
;    1994 draw_pitchbird(v_pitch);
	LDS  R30,_v_pitch
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _draw_pitchbird
;    1995 lcd_circle(32,32,2,1);
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_circle
;    1996 draw_ahiline(v_roll);
	LDS  R30,_v_roll
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _draw_ahiline
;    1997 
;    1998 process0();
	RCALL _process0
;    1999 display_vbat();
	RCALL _display_vbat
;    2000 
;    2001 
;    2002 // print clocks at line2
;    2003 line_buffer[56]=time_hr+0x30;
	LDS  R30,_time_hr
	SUBI R30,-LOW(48)
	__PUTB1MN _line_buffer,56
;    2004 line_buffer[57]=':';
	__POINTW1MN _line_buffer,57
	LDI  R26,LOW(58)
	STD  Z+0,R26
;    2005 line_buffer[58]=time_min1+0x30;
	LDS  R30,_time_min1
	SUBI R30,-LOW(48)
	__PUTB1MN _line_buffer,58
;    2006 line_buffer[59]=time_min+0x30;
	LDS  R30,_time_min
	SUBI R30,-LOW(48)
	__PUTB1MN _line_buffer,59
;    2007 line_buffer[60]=':';
	__POINTW1MN _line_buffer,60
	STD  Z+0,R26
;    2008 line_buffer[61]=time_sec1+0x30;
	LDS  R30,_time_sec1
	SUBI R30,-LOW(48)
	__PUTB1MN _line_buffer,61
;    2009 line_buffer[62]=time_sec+0x30;
	LDS  R30,_time_sec
	SUBI R30,-LOW(48)
	__PUTB1MN _line_buffer,62
;    2010 
;    2011 
;    2012 
;    2013 
;    2014  }
;    2015 
;    2016 #asm
_0x6E:
;    2017 sleep
sleep
;    2018 #endasm
;    2019 } // end main loop
	RJMP _0x6B
;    2020 }
_0x7B:
	RJMP _0x7B
;    2021 
;    2022 
;    2023 
;    2024 
;    2025 
;    2026 
;    2027 
;    2028 
;    2029 	#define graf_dsp    135
;    2030 
;    2031 
;    2032 //***************************Line drawing routine
;    2033 // 2x40 line buffer
;    2034 // 64x64 graphics buffer
;    2035 void draw_line(void)
;    2036 {
_draw_line:
;    2037 #asm("push r31 push r30");
	push r31 push r30
;    2038 if(line==30){	SPCR = (1<<6) | (1<<4) | (1<<2);}
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x7C
	LDI  R30,LOW(84)
	OUT  0x2C,R30
;    2039 	if ((line >= 40) && (line < (48))) // 1st line of 40 chars 8x8
_0x7C:
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x7E
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x7F
_0x7E:
	RJMP _0x7D
_0x7F:
;    2040 	{
;    2041 		TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2042 		while(TCNT0<213); //wait ~7.5us from H-sync
_0x80:
	IN   R30,0x26
	CPI  R30,LOW(0xD5)
	BRLO _0x80
;    2043 	        tmpch=line-40;// R3
	MOVW R30,R4
	SBIW R30,40
	MOV  R3,R30
;    2044 	        DDRB.1=1;
	SBI  0x4,1
;    2045 		PORTB.1=0;
	CBI  0x5,1
;    2046         #asm
;    2047 clr r15 // zero register
clr r15 // zero register
;    2048 ldi r18,40   // counter downto 0
ldi r18,40   // counter downto 0
;    2049 ldi r27,high(_line_buffer)
ldi r27,high(_line_buffer)
;    2050 ldi r26,low(_line_buffer) // XL
ldi r26,low(_line_buffer) // XL
;    2051 ldi r17,8
ldi r17,8
;    2052         // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
        // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
;    2053 write_str:
write_str:
;    2054 ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
;    2055 clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
;    2056 add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
;    2057 lpm r16,Z out SPDR,r16 dec r18 brne write_str
lpm r16,Z out SPDR,r16 dec r18 brne write_str
;    2058 //        wait_t:
//        wait_t:
;    2059 //        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
//        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
;    2060 #endasm
;    2061 TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2062 while(TCNT0<20);
_0x83:
	IN   R30,0x26
	CPI  R30,LOW(0x14)
	BRLO _0x83
;    2063 	        DDRB.1=0;
	CBI  0x4,1
;    2064 	}
;    2065 
;    2066 	else if ((line >= 52) && (line < (60))) // 2nd line of 40 chars 8x8
	RJMP _0x86
_0x7D:
	LDI  R30,LOW(52)
	LDI  R31,HIGH(52)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x88
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x89
_0x88:
	RJMP _0x87
_0x89:
;    2067 	{
;    2068 		TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2069 		while(TCNT0<203); //wait ~7.5us from H-sync  // 10 pts each condition
_0x8A:
	IN   R30,0x26
	CPI  R30,LOW(0xCB)
	BRLO _0x8A
;    2070 	        tmpch=line-52;// R3
	MOVW R30,R4
	SBIW R30,52
	MOV  R3,R30
;    2071 	        DDRB.1=1;
	SBI  0x4,1
;    2072 		PORTB.1=0;
	CBI  0x5,1
;    2073         #asm
;    2074 clr r15 // zero register
clr r15 // zero register
;    2075 ldi r18,40   // counter downto 0
ldi r18,40   // counter downto 0
;    2076 ldi r27,high(_line_buffer+40)
ldi r27,high(_line_buffer+40)
;    2077 ldi r26,low(_line_buffer+40) // XL
ldi r26,low(_line_buffer+40) // XL
;    2078 ldi r17,8
ldi r17,8
;    2079         // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
        // main cycle: spdr=oem6x8[8*line_buffer[cnt]+subline]
;    2080 write_str1:
write_str1:
;    2081 ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
ld r16,X+ mul r16,r17 // line_buffer[cnt]*8
;    2082 clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
clc ldi r31,high(2*_oem6x8) ldi r30,low(2*_oem6x8)  // ZL
;    2083 add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
add r30,r0 adc r31,r1 clc add r30,r3 adc r31,r15
;    2084 lpm r16,Z out SPDR,r16 dec r18 brne write_str1
lpm r16,Z out SPDR,r16 dec r18 brne write_str1
;    2085 //        wait_t:
//        wait_t:
;    2086 //        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
//        in r16,SPSR sbrs r19,7 rjmp wait_t in r16,SPDR
;    2087 #endasm
;    2088 TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2089 while(TCNT0<20);
_0x8D:
	IN   R30,0x26
	CPI  R30,LOW(0x14)
	BRLO _0x8D
;    2090 DDRB.1=0;
	CBI  0x4,1
;    2091 	}
;    2092 //##################### Graphics 64x64
;    2093 	else if ((line >= graf_dsp) && (line < (graf_dsp+64))) // 2nd line of 40 chars 8x8
	RJMP _0x90
_0x87:
	LDI  R30,LOW(135)
	LDI  R31,HIGH(135)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x92
	LDI  R30,LOW(199)
	LDI  R31,HIGH(199)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x93
_0x92:
	RJMP _0x91
_0x93:
;    2094 	{
;    2095 		TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2096 		while(TCNT0<218); //wait ~7.5us from H-sync  // 10 pts each condition
_0x94:
	IN   R30,0x26
	CPI  R30,LOW(0xDA)
	BRLO _0x94
;    2097 		TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;    2098 		while(TCNT0<214); //wait ~7.5us from H-sync  // 10 pts each condition
_0x97:
	IN   R30,0x26
	CPI  R30,LOW(0xD6)
	BRLO _0x97
;    2099 	        tmpch=line-graf_dsp;// R3
	MOVW R30,R4
	SUBI R30,LOW(135)
	SBCI R31,HIGH(135)
	MOV  R3,R30
;    2100 	        DDRB.1=1;
	SBI  0x4,1
;    2101 	        PORTB.1=0;
	CBI  0x5,1
;    2102 		//PORTB.1=1;
;    2103         #asm
;    2104 ldi r18,8   // counter downto 0
ldi r18,8   // counter downto 0
;    2105 ldi r27,high(_ahi_buffer)
ldi r27,high(_ahi_buffer)
;    2106 ldi r26,low(_ahi_buffer) // XL
ldi r26,low(_ahi_buffer) // XL
;    2107 ldi r17,8
ldi r17,8
;    2108 mul r3,r17
mul r3,r17
;    2109 add r26,r0
add r26,r0
;    2110 adc r27,r1
adc r27,r1
;    2111         // main cycle: spdr=ahi_buffer[8*r3+r18]
        // main cycle: spdr=ahi_buffer[8*r3+r18]
;    2112 #define _PORTB 5
#define _PORTB 5
;    2113 write_str2:
write_str2:
;    2114 ld r16,X+
ld r16,X+  
;    2115 rol r16
rol r16
;    2116 out _PORTB,r16
out _PORTB,r16
;    2117 nop
nop   
;    2118 nop
nop   
;    2119 ror r16
ror r16
;    2120 out _PORTB,r16
out _PORTB,r16
;    2121 nop
nop   
;    2122 nop
nop   
;    2123 ror r16
ror r16
;    2124 out _PORTB,r16
out _PORTB,r16
;    2125 nop
nop   
;    2126 nop
nop   
;    2127 ror r16
ror r16
;    2128 out _PORTB,r16
out _PORTB,r16
;    2129 nop
nop   
;    2130 nop
nop   
;    2131 ror r16
ror r16
;    2132 out _PORTB,r16
out _PORTB,r16
;    2133 nop
nop   
;    2134 nop
nop   
;    2135 ror r16
ror r16
;    2136 out _PORTB,r16
out _PORTB,r16
;    2137 nop
nop   
;    2138 nop
nop   
;    2139 ror r16
ror r16
;    2140 out _PORTB,r16
out _PORTB,r16
;    2141 nop
nop   
;    2142 ror r16
ror r16
;    2143 dec r18
dec r18
;    2144 out _PORTB,r16
out _PORTB,r16
;    2145 brne write_str2
brne write_str2
;    2146 #endasm
;    2147 PORTB.1=0;
	CBI  0x5,1
;    2148 DDRB.1=0;
	CBI  0x4,1
;    2149 
;    2150 	}else if (line==graf_dsp+64) {flag=1;}
	RJMP _0x9A
_0x91:
	LDI  R30,LOW(199)
	LDI  R31,HIGH(199)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x9B
	LDI  R30,LOW(1)
	MOV  R7,R30
;    2151 
;    2152 
;    2153 if(UCSR0A&128) receive_rx();
_0x9B:
_0x9A:
_0x90:
_0x86:
	LDS  R30,192
	ANDI R30,LOW(0x80)
	BREQ _0x9C
	RCALL _receive_rx
;    2154 
;    2155 
;    2156 #asm("pop r30 pop r31");
_0x9C:
	pop r30 pop r31
;    2157 
;    2158 //***************************end Line drawing routine
;    2159 }
	RET
;    2160 
;    2161 
;    2162 
;    2163 
;    2164 
;    2165 
;    2166 
;    2167 
;    2168 
;    2169 
;    2170 
;    2171 
;    2172 
;    2173 
;    2174 void config(void)
;    2175 {
_config:
;    2176 	// PORT B - Video Out
;    2177 	//PB0 used for background dimming
;    2178 	PORTB = 0x00;							// Initial state is everything off
	LDI  R30,LOW(0)
	OUT  0x5,R30
;    2179 	DDRB  = 0x3d;							// Data direction register for port B
	LDI  R30,LOW(61)
	OUT  0x4,R30
;    2180         DDRB.1=1;
	SBI  0x4,1
;    2181 	// PORT D - Not really used
;    2182 	//	Bit/Pin 2 (out) connected the control line on a servo
;    2183 	PORTD = 0x00;							// Initial state is everything off
	LDI  R30,LOW(0)
	OUT  0xB,R30
;    2184 	DDRD  = 0x00;							// Data direction register for port D
	OUT  0xA,R30
;    2185 
;    2186 	//enable the SPI port
;    2187 	SPDR = 0; //CLEAR THE SPI DATA REGISTER!!! OR WILL HOSE THE VIDEO RANDOMLY IF NOT CLEARED!
	OUT  0x2E,R30
;    2188 	SPCR = (1<<6) | (1<<4) | (1<<2);
	LDI  R30,LOW(84)
	OUT  0x2C,R30
;    2189 	SPSR = 1;
	LDI  R30,LOW(1)
	OUT  0x2D,R30
;    2190 
;    2191 	// Set baud rate of USART to 9600 baud at 8 MHz
;    2192 UCSR0A=0x00;
	LDI  R30,LOW(0)
	STS  192,R30
;    2193 UCSR0B=0x10;
	LDI  R30,LOW(16)
	STS  193,R30
;    2194 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
;    2195 UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
;    2196 UBRR0L=0x9f;//0x33;
	LDI  R30,LOW(159)
	STS  196,R30
;    2197 
;    2198 	// Setup idle mode sleeps
;    2199 
;    2200 	//set_sleep_mode(SLEEP_MODE_IDLE);
;    2201 
;    2202 	TCCR0B = 0x01; //enable timer w/ no prescaling
	LDI  R30,LOW(1)
	OUT  0x25,R30
;    2203 
;    2204 	TCCR2B = 0x02; //enable timer with /8 prescale
	LDI  R30,LOW(2)
	STS  177,R30
;    2205 	TCNT2 = 84; //overflow will happen after 80us
	LDI  R30,LOW(84)
	STS  178,R30
;    2206 
;    2207 	//TIMSK2 = 1;
;    2208 
;    2209 	EICRA=3; // interrupt for char generator
	LDI  R30,LOW(3)
	STS  105,R30
;    2210 	EIMSK=1;
	LDI  R30,LOW(1)
	OUT  0x1D,R30
;    2211 	line=line_buffer[0];
	LDS  R4,_line_buffer
	CLR  R5
;    2212 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;    2213 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;    2214 
;    2215 // ADC initialization
;    2216 // ADC Clock frequency: 125.000 kHz
;    2217 // ADC Voltage Reference: AVCC pin
;    2218 // ADC Auto Trigger Source: Free Running
;    2219 // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
;    2220 // ADC4: On, ADC5: On
;    2221 DIDR0=0x00;
	STS  126,R30
;    2222 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	STS  124,R30
;    2223 ADCSRA=0xA6;
	LDI  R30,LOW(166)
	STS  122,R30
;    2224 ADCSRB&=0xF8;
	LDS  R30,123
	ANDI R30,LOW(0xF8)
	STS  123,R30
;    2225 
;    2226 
;    2227 	line=0; //reset the line counter
	CLR  R4
	CLR  R5
;    2228 
;    2229 #asm("sei")
	sei
;    2230 
;    2231 }
	RET

_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	__GETD2S 5
	__GETD1N 0x3E22F983
	RCALL __MULF12
	__PUTD1S 5
	RCALL __PUTPARD1
	RCALL _floor
	__GETD2S 5
	RCALL __SWAPD12
	RCALL __SUBF12
	__PUTD1S 5
	__GETD2S 5
	__GETD1N 0x3F000000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x9D
	RCALL __SWAPD12
	RCALL __SUBF12
	__PUTD1S 5
	LDI  R17,LOW(1)
_0x9D:
	__GETD2S 5
	__GETD1N 0x3E800000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x9E
	__GETD1N 0x3F000000
	RCALL __SUBF12
	__PUTD1S 5
_0x9E:
	CPI  R17,0
	BREQ _0x9F
	__GETD1S 5
	RCALL __ANEGF1
	__PUTD1S 5
_0x9F:
	__GETD1S 5
	__GETD2S 5
	RCALL __MULF12
	__PUTD1S 1
	__GETD2N 0x4226C4B1
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	RCALL __SWAPD12
	RCALL __SUBF12
	__GETD2S 1
	RCALL __MULF12
	__GETD2N 0x4104534C
	RCALL __ADDF12
	__GETD2S 5
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 1
	__GETD2N 0x3FDEED11
	RCALL __ADDF12
	__GETD2S 1
	RCALL __MULF12
	__GETD2N 0x3FA87B5E
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	__GETD2S 0
	__GETD1N 0x3FC90FDB
	RCALL __SUBF12
	RCALL __PUTPARD1
	RCALL _sin
	ADIW R28,4
	RET

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
